/*
 * Copyright (c) 2006, 2008 by Abacus Research AG, Switzerland.
 * All rights reserved.
 *
 * This file is part of the Abacus Formula Compiler (AFC).
 *
 * For commercial licensing, please contact sales(at)formulacompiler.com.
 *
 * AFC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * AFC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AFC.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.formulacompiler.compiler.internal.model.rewriting;

import java.util.Iterator;

import org.formulacompiler.compiler.Function;
import org.formulacompiler.compiler.Operator;
import org.formulacompiler.compiler.internal.expressions.*;
import static org.formulacompiler.compiler.internal.expressions.ExpressionBuilder.*;


/**
 * THIS IS GENERATED CODE. DO NOT MODIFY.
 */
final class GeneratedFunctionRewriter extends AbstractExpressionRewriter
{

	public GeneratedFunctionRewriter( NameSanitizer _sanitizer )
	{
		super( _sanitizer );
	}

	
	public final ExpressionNode rewrite( ExpressionNodeForFunction _fun )
	{
		switch (_fun.getFunction()) {
      case GEOMEAN:
        return rewriteGEOMEAN( _fun );
      case HARMEAN:
        return rewriteHARMEAN( _fun );
      case PERMUT:
        switch (_fun.cardinality()) {
          case 2:
            return rewritePERMUT_2( _fun );
        }
        break;
      case COMBIN:
        switch (_fun.cardinality()) {
          case 2:
            return rewriteCOMBIN_2( _fun );
        }
        break;
      case NPV:
        switch (_fun.cardinality()) {
          case 2:
            return rewriteNPV_2( _fun );
        }
        break;
      case MIRR:
        switch (_fun.cardinality()) {
          case 3:
            return rewriteMIRR_3( _fun );
        }
        break;
      case SLN:
        switch (_fun.cardinality()) {
          case 3:
            return rewriteSLN_3( _fun );
        }
        break;
      case SYD:
        switch (_fun.cardinality()) {
          case 4:
            return rewriteSYD_4( _fun );
        }
        break;
      case FV:
        switch (_fun.cardinality()) {
          case 3:
            return rewriteFV_3( _fun );
          case 4:
            return rewriteFV_4( _fun );
          case 5:
            return rewriteFV_5( _fun );
        }
        break;
      case NPER:
        switch (_fun.cardinality()) {
          case 3:
            return rewriteNPER_3( _fun );
          case 4:
            return rewriteNPER_4( _fun );
          case 5:
            return rewriteNPER_5( _fun );
        }
        break;
      case PMT:
        switch (_fun.cardinality()) {
          case 3:
            return rewritePMT_3( _fun );
          case 4:
            return rewritePMT_4( _fun );
          case 5:
            return rewritePMT_5( _fun );
        }
        break;
      case PV:
        switch (_fun.cardinality()) {
          case 3:
            return rewritePV_3( _fun );
          case 4:
            return rewritePV_4( _fun );
          case 5:
            return rewritePV_5( _fun );
        }
        break;
      case VDB:
        switch (_fun.cardinality()) {
          case 5:
            return rewriteVDB_5( _fun );
          case 6:
            return rewriteVDB_6( _fun );
        }
        break;
      case RANK:
        switch (_fun.cardinality()) {
          case 2:
            return rewriteRANK_2( _fun );
          case 3:
            return rewriteRANK_3( _fun );
        }
        break;
      case VAR:
        return rewriteVAR( _fun );
      case VARP:
        return rewriteVARP( _fun );
      case STDEV:
        return rewriteSTDEV( _fun );
      case STDEVP:
        return rewriteSTDEVP( _fun );
      case AVEDEV:
        return rewriteAVEDEV( _fun );
      case DEVSQ:
        return rewriteDEVSQ( _fun );
      case COVAR:
        switch (_fun.cardinality()) {
          case 2:
            return rewriteCOVAR_2( _fun );
        }
        break;
      case SKEW:
        return rewriteSKEW( _fun );
      case KURT:
        return rewriteKURT( _fun );
      case CONFIDENCE:
        switch (_fun.cardinality()) {
          case 3:
            return rewriteCONFIDENCE_3( _fun );
        }
        break;
      case NORMDIST:
        switch (_fun.cardinality()) {
          case 4:
            return rewriteNORMDIST_4( _fun );
        }
        break;
      case NORMSDIST:
        switch (_fun.cardinality()) {
          case 1:
            return rewriteNORMSDIST_1( _fun );
        }
        break;
      case NORMINV:
        switch (_fun.cardinality()) {
          case 3:
            return rewriteNORMINV_3( _fun );
        }
        break;
      case NORMSINV:
        switch (_fun.cardinality()) {
          case 1:
            return rewriteNORMSINV_1( _fun );
        }
        break;
      case LOGNORMDIST:
        switch (_fun.cardinality()) {
          case 3:
            return rewriteLOGNORMDIST_3( _fun );
        }
        break;
      case LOGINV:
        switch (_fun.cardinality()) {
          case 3:
            return rewriteLOGINV_3( _fun );
        }
        break;
      case BETADIST:
        switch (_fun.cardinality()) {
          case 4:
            return rewriteBETADIST_4( _fun );
          case 5:
            return rewriteBETADIST_5( _fun );
        }
        break;
      case BETAINV:
        switch (_fun.cardinality()) {
          case 4:
            return rewriteBETAINV_4( _fun );
          case 5:
            return rewriteBETAINV_5( _fun );
        }
        break;
      case CHITEST:
        switch (_fun.cardinality()) {
          case 6:
            return rewriteCHITEST_6( _fun );
        }
        break;
      case EXPONDIST:
        switch (_fun.cardinality()) {
          case 3:
            return rewriteEXPONDIST_3( _fun );
        }
        break;
      case FDIST:
        switch (_fun.cardinality()) {
          case 3:
            return rewriteFDIST_3( _fun );
        }
        break;
      case FTEST:
        switch (_fun.cardinality()) {
          case 2:
            return rewriteFTEST_2( _fun );
        }
        break;
      case FISHER:
        switch (_fun.cardinality()) {
          case 1:
            return rewriteFISHER_1( _fun );
        }
        break;
      case FISHERINV:
        switch (_fun.cardinality()) {
          case 1:
            return rewriteFISHERINV_1( _fun );
        }
        break;
      case NEGBINOMDIST:
        switch (_fun.cardinality()) {
          case 3:
            return rewriteNEGBINOMDIST_3( _fun );
        }
        break;
      case PEARSON:
        switch (_fun.cardinality()) {
          case 2:
            return rewritePEARSON_2( _fun );
        }
        break;
      case RSQ:
        switch (_fun.cardinality()) {
          case 2:
            return rewriteRSQ_2( _fun );
        }
        break;
      case STANDARDIZE:
        switch (_fun.cardinality()) {
          case 3:
            return rewriteSTANDARDIZE_3( _fun );
        }
        break;
      case TTEST:
        switch (_fun.cardinality()) {
          case 4:
            return rewriteTTEST_4( _fun );
        }
        break;
      case ZTEST:
        switch (_fun.cardinality()) {
          case 2:
            return rewriteZTEST_2( _fun );
          case 3:
            return rewriteZTEST_3( _fun );
        }
        break;
      case STDEVPA:
        return rewriteSTDEVPA( _fun );
      case SUMX2MY2:
        switch (_fun.cardinality()) {
          case 2:
            return rewriteSUMX2MY2_2( _fun );
        }
        break;
      case SUMX2PY2:
        switch (_fun.cardinality()) {
          case 2:
            return rewriteSUMX2PY2_2( _fun );
        }
        break;
      case SUMXMY2:
        switch (_fun.cardinality()) {
          case 2:
            return rewriteSUMXMY2_2( _fun );
        }
        break;
      case VARA:
        return rewriteVARA( _fun );
      case STEYX:
        switch (_fun.cardinality()) {
          case 2:
            return rewriteSTEYX_2( _fun );
        }
        break;
      case CORREL:
        switch (_fun.cardinality()) {
          case 2:
            return rewriteCORREL_2( _fun );
        }
        break;
      case INTERCEPT:
        switch (_fun.cardinality()) {
          case 2:
            return rewriteINTERCEPT_2( _fun );
        }
        break;
      case SLOPE:
        switch (_fun.cardinality()) {
          case 2:
            return rewriteSLOPE_2( _fun );
        }
        break;
      case FORECAST:
        switch (_fun.cardinality()) {
          case 3:
            return rewriteFORECAST_3( _fun );
        }
        break;
      case PROB:
        switch (_fun.cardinality()) {
          case 3:
            return rewritePROB_3( _fun );
          case 4:
            return rewritePROB_4( _fun );
        }
        break;
      case LARGE:
        switch (_fun.cardinality()) {
          case 2:
            return rewriteLARGE_2( _fun );
        }
        break;
      case MEDIAN:
        return rewriteMEDIAN( _fun );
      case MODE:
        return rewriteMODE( _fun );
      case PERCENTILE:
        switch (_fun.cardinality()) {
          case 2:
            return rewritePERCENTILE_2( _fun );
        }
        break;
      case PERCENTRANK:
        switch (_fun.cardinality()) {
          case 2:
            return rewritePERCENTRANK_2( _fun );
          case 3:
            return rewritePERCENTRANK_3( _fun );
        }
        break;
      case QUARTILE:
        switch (_fun.cardinality()) {
          case 2:
            return rewriteQUARTILE_2( _fun );
        }
        break;
      case SMALL:
        switch (_fun.cardinality()) {
          case 2:
            return rewriteSMALL_2( _fun );
        }
        break;
      case TRIMMEAN:
        switch (_fun.cardinality()) {
          case 2:
            return rewriteTRIMMEAN_2( _fun );
        }
        break;
      case DAYS360:
        switch (_fun.cardinality()) {
          case 2:
            return rewriteDAYS360_2( _fun );
        }
        break;
      case SUM:
        return rewriteSUM( _fun );
      case PRODUCT:
        return rewritePRODUCT( _fun );
      case MIN:
        return rewriteMIN( _fun );
      case MAX:
        return rewriteMAX( _fun );
      case COUNTA:
        return rewriteCOUNTA( _fun );
      case AVERAGE:
        return rewriteAVERAGE( _fun );
      case SUMSQ:
        return rewriteSUMSQ( _fun );

		}
		return _fun;
	}


  final ExpressionNode fold_product() {
    final String s$ = "s__" + newSanitizingSuffix();
    final ExpressionNode s = var( s$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    return new ExpressionNodeForFoldDefinition( new String[] {s$}, new ExpressionNode[] {cst( 1.0 )}, null, new String[] {xi$}, new ExpressionNode[] {op( Operator.TIMES, s, xi )}, null, null, cst( 0.0 ), true, true );
  }

  final ExpressionNode fold_var() {
    final String s$ = "s__" + newSanitizingSuffix();
    final ExpressionNode s = var( s$ );
    final String ss$ = "ss__" + newSanitizingSuffix();
    final ExpressionNode ss = var( ss$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    final String n$ = "n__" + newSanitizingSuffix();
    final ExpressionNode n = var( n$ );
    return new ExpressionNodeForFoldDefinition( new String[] {s$, ss$}, new ExpressionNode[] {cst( 0.0 ), cst( 0.0 )}, null, new String[] {xi$}, new ExpressionNode[] {op( Operator.PLUS, s, xi ), op( Operator.PLUS, ss, op( Operator.TIMES, xi, xi ) )}, n$, op( Operator.DIV, op( Operator.MINUS, ss, op( Operator.DIV, op( Operator.TIMES, s, s ), n ) ), op( Operator.MINUS, n, cst( 1.0 ) ) ), null, true, false );
  }

  final ExpressionNode fold_sum() {
    final String s$ = "s__" + newSanitizingSuffix();
    final ExpressionNode s = var( s$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    return new ExpressionNodeForFoldDefinition( new String[] {s$}, new ExpressionNode[] {cst( 0.0 )}, null, new String[] {xi$}, new ExpressionNode[] {op( Operator.PLUS, s, xi )}, null, null, null, true, true );
  }

  final ExpressionNode fold_min() {
    final String m$ = "m__" + newSanitizingSuffix();
    final ExpressionNode m = var( m$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    return new ExpressionNodeForFoldDefinition( new String[] {m$}, new ExpressionNode[] {new ExpressionNodeForMaxValue()}, null, new String[] {xi$}, new ExpressionNode[] {op( Operator.INTERNAL_MIN, m, xi )}, null, null, cst( 0.0 ), true, true );
  }

  final ExpressionNode fold_average() {
    final String s$ = "s__" + newSanitizingSuffix();
    final ExpressionNode s = var( s$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    final String n$ = "n__" + newSanitizingSuffix();
    final ExpressionNode n = var( n$ );
    return new ExpressionNodeForFoldDefinition( new String[] {s$}, new ExpressionNode[] {cst( 0.0 )}, null, new String[] {xi$}, new ExpressionNode[] {op( Operator.PLUS, s, xi )}, n$, op( Operator.DIV, s, n ), null, true, true );
  }

  final ExpressionNode fold_get() {
    final String r$ = "r__" + newSanitizingSuffix();
    final ExpressionNode r = var( r$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    final String n$ = "n__" + newSanitizingSuffix();
    final ExpressionNode n = var( n$ );
    return new ExpressionNodeForFoldDefinition( new String[] {r$}, new ExpressionNode[] {cst( 0.0 )}, null, new String[] {xi$}, new ExpressionNode[] {xi}, n$, fun( Function.IF, op( Operator.EQUAL, n, cst( 0.0 ) ), fun( Function.ERROR, cst( "#VALUE! because selection empty in DGET" ) ), fun( Function.IF, op( Operator.GREATER, n, cst( 1.0 ) ), fun( Function.ERROR, cst( "#NUM! because selection ambiguous in DGET" ) ), r ) ), null, true, false );
  }

  final ExpressionNode fold_varp() {
    final String s$ = "s__" + newSanitizingSuffix();
    final ExpressionNode s = var( s$ );
    final String ss$ = "ss__" + newSanitizingSuffix();
    final ExpressionNode ss = var( ss$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    final String n$ = "n__" + newSanitizingSuffix();
    final ExpressionNode n = var( n$ );
    return new ExpressionNodeForFoldDefinition( new String[] {s$, ss$}, new ExpressionNode[] {cst( 0.0 ), cst( 0.0 )}, null, new String[] {xi$}, new ExpressionNode[] {op( Operator.PLUS, s, xi ), op( Operator.PLUS, ss, op( Operator.TIMES, xi, xi ) )}, n$, op( Operator.DIV, op( Operator.MINUS, ss, op( Operator.DIV, op( Operator.TIMES, s, s ), n ) ), n ), null, true, false );
  }

  final ExpressionNode fold_max() {
    final String m$ = "m__" + newSanitizingSuffix();
    final ExpressionNode m = var( m$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    return new ExpressionNodeForFoldDefinition( new String[] {m$}, new ExpressionNode[] {new ExpressionNodeForMinValue()}, null, new String[] {xi$}, new ExpressionNode[] {op( Operator.INTERNAL_MAX, m, xi )}, null, null, cst( 0.0 ), true, true );
  }

  private final ExpressionNode rewriteGEOMEAN( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args );
    final String errFlag$ = "errFlag__" + newSanitizingSuffix();
    final ExpressionNode errFlag = var( errFlag$ );
    final String p$ = "p__" + newSanitizingSuffix();
    final ExpressionNode p = var( p$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    final String n$ = "n__" + newSanitizingSuffix();
    final ExpressionNode n = var( n$ );
    return new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldList( new ExpressionNodeForFoldDefinition( new String[] {errFlag$, p$}, new ExpressionNode[] {cst( 0.0 ), cst( 1.0 )}, null, new String[] {xi$}, new ExpressionNode[] {fun( Function.IF, op( Operator.LESSOREQUAL, xi, cst( 0.0 ) ), cst( 1.0 ), errFlag ), op( Operator.TIMES, p, xi )}, n$, fun( Function.IF, op( Operator.NOTEQUAL, errFlag, cst( 0.0 ) ), fun( Function.ERROR, cst( "#NUM! because xi <= 0 in GEOMEAN" ) ), op( Operator.EXP, p, op( Operator.DIV, cst( 1.0 ), n ) ) ), null, true, true ), xs );
  }

  private final ExpressionNode rewriteHARMEAN( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args );
    final String errFlag$ = "errFlag__" + newSanitizingSuffix();
    final ExpressionNode errFlag = var( errFlag$ );
    final String r$ = "r__" + newSanitizingSuffix();
    final ExpressionNode r = var( r$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    final String n$ = "n__" + newSanitizingSuffix();
    final ExpressionNode n = var( n$ );
    return new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldList( new ExpressionNodeForFoldDefinition( new String[] {errFlag$, r$}, new ExpressionNode[] {cst( 0.0 ), cst( 0.0 )}, null, new String[] {xi$}, new ExpressionNode[] {fun( Function.IF, op( Operator.LESSOREQUAL, xi, cst( 0.0 ) ), cst( 1.0 ), errFlag ), fun( Function.IF, op( Operator.NOTEQUAL, xi, cst( 0.0 ) ), op( Operator.PLUS, r, op( Operator.DIV, cst( 1.0 ), xi ) ), r )}, n$, fun( Function.IF, op( Operator.NOTEQUAL, errFlag, cst( 0.0 ) ), fun( Function.ERROR, cst( "#NUM! because xi <= 0 in HARMEAN" ) ), op( Operator.DIV, n, r ) ), null, true, false ), xs );
  }

  private final ExpressionNode rewritePERMUT_2( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode n = substitution( args.next() );
    final ExpressionNode k = substitution( args.next() );
    final String ni$ = "ni__" + newSanitizingSuffix();
    final ExpressionNode ni = var( ni$ );
    final String ki$ = "ki__" + newSanitizingSuffix();
    final ExpressionNode ki = var( ki$ );
    return let( ni$, fun( Function.INT, n ), let( ki$, fun( Function.INT, k ), fun( Function.IF, op( Operator.LESS, ni, cst( 0.0 ) ), fun( Function.ERROR, cst( "#NUM! because n < 0 in PERMUT" ) ), fun( Function.IF, op( Operator.LESS, ki, cst( 0.0 ) ), fun( Function.ERROR, cst( "#NUM! because k < 0 in PERMUT" ) ), fun( Function.IF, op( Operator.LESS, ni, ki ), fun( Function.ERROR, cst( "#NUM! because n < k in PERMUT" ) ), op( Operator.DIV, fun( Function.FACT, ni ), fun( Function.FACT, op( Operator.MINUS, ni, ki ) ) ) ) ) ) ) );
  }

  private final ExpressionNode rewriteCOMBIN_2( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final String n$ = "n__" + newSanitizingSuffix();
    final ExpressionNode n = var( n$ );
    final ExpressionNode n$$ = args.next();
    final String k$ = "k__" + newSanitizingSuffix();
    final ExpressionNode k = var( k$ );
    final ExpressionNode k$$ = args.next();
    return let( n$, n$$, let( k$, k$$, fun( Function.IF, fun( Function.OR, op( Operator.LESS, n, cst( 0.0 ) ), op( Operator.LESS, k, cst( 0.0 ) ), op( Operator.LESS, n, k ) ), fun( Function.ERROR, cst( "#NUM! because n < 0 or k < 0 or n < k in COMBIN" ) ), fun( Function.IF, op( Operator.EQUAL, n, k ), cst( 1.0 ), fun( Function.IF, op( Operator.EQUAL, k, cst( 1.0 ) ), n, op( Operator.DIV, op( Operator.DIV, fun( Function.FACT, n ), fun( Function.FACT, k ) ), fun( Function.FACT, op( Operator.MINUS, n, k ) ) ) ) ) ) ) );
  }

  private final ExpressionNode rewriteNPV_2( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode rate = substitution( args.next() );
    final ExpressionNode vs = substitution( args.next() );
    final String rate1$ = "rate1__" + newSanitizingSuffix();
    final ExpressionNode rate1 = var( rate1$ );
    final String r$ = "r__" + newSanitizingSuffix();
    final ExpressionNode r = var( r$ );
    final String i$ = "i__" + newSanitizingSuffix();
    final ExpressionNode i = var( i$ );
    final String vi$ = "vi__" + newSanitizingSuffix();
    final ExpressionNode vi = var( vi$ );
    return let( rate1$, op( Operator.PLUS, rate, cst( 1.0 ) ), new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldVectors( new ExpressionNodeForFoldDefinition( new String[] {r$}, new ExpressionNode[] {cst( 0.0 )}, i$, new String[] {vi$}, new ExpressionNode[] {op( Operator.PLUS, r, op( Operator.DIV, vi, op( Operator.EXP, rate1, i ) ) )}, null, null, null, false, false ), vs ) );
  }

  private final ExpressionNode rewriteMIRR_3( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode vs = substitution( args.next() );
    final ExpressionNode frate = substitution( args.next() );
    final ExpressionNode rrate = substitution( args.next() );
    final String n$ = "n__" + newSanitizingSuffix();
    final ExpressionNode n = var( n$ );
    final String rrate1$ = "rrate1__" + newSanitizingSuffix();
    final ExpressionNode rrate1 = var( rrate1$ );
    final String frate1$ = "frate1__" + newSanitizingSuffix();
    final ExpressionNode frate1 = var( frate1$ );
    final String r1$ = "r1__" + newSanitizingSuffix();
    final ExpressionNode r1 = var( r1$ );
    final String r2$ = "r2__" + newSanitizingSuffix();
    final ExpressionNode r2 = var( r2$ );
    final String i$ = "i__" + newSanitizingSuffix();
    final ExpressionNode i = var( i$ );
    final String vi$ = "vi__" + newSanitizingSuffix();
    final ExpressionNode vi = var( vi$ );
    return let( n$, fun( Function.COUNT, vs ), let( rrate1$, op( Operator.PLUS, rrate, cst( 1.0 ) ), let( frate1$, op( Operator.PLUS, frate, cst( 1.0 ) ), new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldVectors( new ExpressionNodeForFoldDefinition( new String[] {r1$, r2$}, new ExpressionNode[] {cst( 0.0 ), cst( 0.0 )}, i$, new String[] {vi$}, new ExpressionNode[] {op( Operator.PLUS, r1, fun( Function.IF, op( Operator.GREATER, vi, cst( 0.0 ) ), op( Operator.TIMES, vi, op( Operator.EXP, rrate1, op( Operator.MINUS, n, i ) ) ), cst( 0.0 ) ) ), op( Operator.PLUS, r2, fun( Function.IF, op( Operator.LESS, vi, cst( 0.0 ) ), op( Operator.DIV, vi, op( Operator.EXP, frate1, op( Operator.MINUS, i, cst( 1.0 ) ) ) ), cst( 0.0 ) ) )}, null, op( Operator.MINUS, op( Operator.EXP, op( Operator.DIV, op( Operator.MINUS, r1 ), r2 ), op( Operator.DIV, cst( 1.0 ), op( Operator.MINUS, n, cst( 1.0 ) ) ) ), cst( 1.0 ) ), null, false, false ), vs ) ) ) );
  }

  private final ExpressionNode rewriteSLN_3( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode cost = substitution( args.next() );
    final ExpressionNode salvage = substitution( args.next() );
    final ExpressionNode life = substitution( args.next() );
    return op( Operator.DIV, op( Operator.MINUS, cost, salvage ), life );
  }

  private final ExpressionNode rewriteSYD_4( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode cost = substitution( args.next() );
    final ExpressionNode salvage = substitution( args.next() );
    final String life$ = "life__" + newSanitizingSuffix();
    final ExpressionNode life = var( life$ );
    final ExpressionNode life$$ = args.next();
    final ExpressionNode per = substitution( args.next() );
    return let( life$, life$$, op( Operator.DIV, op( Operator.TIMES, op( Operator.TIMES, op( Operator.MINUS, cost, salvage ), op( Operator.PLUS, op( Operator.MINUS, life, per ), cst( 1.0 ) ) ), cst( 2.0 ) ), op( Operator.TIMES, life, op( Operator.PLUS, life, cst( 1.0 ) ) ) ) );
  }

  private final ExpressionNode rewriteFV_3( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode rate = substitution( args.next() );
    final ExpressionNode nper = substitution( args.next() );
    final ExpressionNode pmt = substitution( args.next() );
    return fun( Function.FV, rate, nper, pmt, cst( 0.0 ), cst( 0.0 ) );
  }

  private final ExpressionNode rewriteFV_4( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode rate = substitution( args.next() );
    final ExpressionNode nper = substitution( args.next() );
    final ExpressionNode pmt = substitution( args.next() );
    final ExpressionNode pv = substitution( args.next() );
    return fun( Function.FV, rate, nper, pmt, pv, cst( 0.0 ) );
  }

  private final ExpressionNode rewriteFV_5( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final String rate$ = "rate__" + newSanitizingSuffix();
    final ExpressionNode rate = var( rate$ );
    final ExpressionNode rate$$ = args.next();
    final String nper$ = "nper__" + newSanitizingSuffix();
    final ExpressionNode nper = var( nper$ );
    final ExpressionNode nper$$ = args.next();
    final String pmt$ = "pmt__" + newSanitizingSuffix();
    final ExpressionNode pmt = var( pmt$ );
    final ExpressionNode pmt$$ = args.next();
    final String pv$ = "pv__" + newSanitizingSuffix();
    final ExpressionNode pv = var( pv$ );
    final ExpressionNode pv$$ = args.next();
    final ExpressionNode type = substitution( args.next() );
    final String p$ = "p__" + newSanitizingSuffix();
    final ExpressionNode p = var( p$ );
    final String k$ = "k__" + newSanitizingSuffix();
    final ExpressionNode k = var( k$ );
    return let( rate$, rate$$, let( nper$, nper$$, let( pmt$, pmt$$, let( pv$, pv$$, fun( Function.IF, op( Operator.EQUAL, rate, cst( 0.0 ) ), op( Operator.MINUS, op( Operator.MINUS, pv ), op( Operator.TIMES, pmt, nper ) ), let( p$, op( Operator.EXP, op( Operator.PLUS, rate, cst( 1.0 ) ), nper ), let( k$, fun( Function.IF, op( Operator.GREATER, type, cst( 0.0 ) ), op( Operator.PLUS, rate, cst( 1.0 ) ), cst( 1.0 ) ), op( Operator.MINUS, op( Operator.TIMES, op( Operator.MINUS, pv ), p ), op( Operator.DIV, op( Operator.TIMES, op( Operator.TIMES, pmt, op( Operator.MINUS, p, cst( 1.0 ) ) ), k ), rate ) ) ) ) ) ) ) ) );
  }

  private final ExpressionNode rewriteNPER_3( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode rate = substitution( args.next() );
    final ExpressionNode pmt = substitution( args.next() );
    final ExpressionNode pv = substitution( args.next() );
    return fun( Function.NPER, rate, pmt, pv, cst( 0.0 ), cst( 0.0 ) );
  }

  private final ExpressionNode rewriteNPER_4( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode rate = substitution( args.next() );
    final ExpressionNode pmt = substitution( args.next() );
    final ExpressionNode pv = substitution( args.next() );
    final ExpressionNode fv = substitution( args.next() );
    return fun( Function.NPER, rate, pmt, pv, fv, cst( 0.0 ) );
  }

  private final ExpressionNode rewriteNPER_5( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final String rate$ = "rate__" + newSanitizingSuffix();
    final ExpressionNode rate = var( rate$ );
    final ExpressionNode rate$$ = args.next();
    final String pmt$ = "pmt__" + newSanitizingSuffix();
    final ExpressionNode pmt = var( pmt$ );
    final ExpressionNode pmt$$ = args.next();
    final String pv$ = "pv__" + newSanitizingSuffix();
    final ExpressionNode pv = var( pv$ );
    final ExpressionNode pv$$ = args.next();
    final String fv$ = "fv__" + newSanitizingSuffix();
    final ExpressionNode fv = var( fv$ );
    final ExpressionNode fv$$ = args.next();
    final ExpressionNode type = substitution( args.next() );
    final String a$ = "a__" + newSanitizingSuffix();
    final ExpressionNode a = var( a$ );
    return let( rate$, rate$$, let( pmt$, pmt$$, let( pv$, pv$$, let( fv$, fv$$, fun( Function.IF, op( Operator.EQUAL, rate, cst( 0.0 ) ), op( Operator.DIV, op( Operator.MINUS, op( Operator.PLUS, pv, fv ) ), pmt ), let( a$, fun( Function.IF, op( Operator.GREATER, type, cst( 0.0 ) ), op( Operator.TIMES, pmt, op( Operator.PLUS, cst( 1.0 ), rate ) ), pmt ), fun( Function.LOG, op( Operator.DIV, op( Operator.MINUS, op( Operator.MINUS, op( Operator.TIMES, rate, fv ), a ) ), op( Operator.PLUS, op( Operator.TIMES, rate, pv ), a ) ), op( Operator.PLUS, cst( 1.0 ), rate ) ) ) ) ) ) ) );
  }

  private final ExpressionNode rewritePMT_3( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode rate = substitution( args.next() );
    final ExpressionNode nper = substitution( args.next() );
    final ExpressionNode pv = substitution( args.next() );
    return fun( Function.PMT, rate, nper, pv, cst( 0.0 ), cst( 0.0 ) );
  }

  private final ExpressionNode rewritePMT_4( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode rate = substitution( args.next() );
    final ExpressionNode nper = substitution( args.next() );
    final ExpressionNode pv = substitution( args.next() );
    final ExpressionNode fv = substitution( args.next() );
    return fun( Function.PMT, rate, nper, pv, fv, cst( 0.0 ) );
  }

  private final ExpressionNode rewritePMT_5( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final String rate$ = "rate__" + newSanitizingSuffix();
    final ExpressionNode rate = var( rate$ );
    final ExpressionNode rate$$ = args.next();
    final String nper$ = "nper__" + newSanitizingSuffix();
    final ExpressionNode nper = var( nper$ );
    final ExpressionNode nper$$ = args.next();
    final String pv$ = "pv__" + newSanitizingSuffix();
    final ExpressionNode pv = var( pv$ );
    final ExpressionNode pv$$ = args.next();
    final String fv$ = "fv__" + newSanitizingSuffix();
    final ExpressionNode fv = var( fv$ );
    final ExpressionNode fv$$ = args.next();
    final ExpressionNode type = substitution( args.next() );
    final String a$ = "a__" + newSanitizingSuffix();
    final ExpressionNode a = var( a$ );
    final String b$ = "b__" + newSanitizingSuffix();
    final ExpressionNode b = var( b$ );
    final String c$ = "c__" + newSanitizingSuffix();
    final ExpressionNode c = var( c$ );
    final String d$ = "d__" + newSanitizingSuffix();
    final ExpressionNode d = var( d$ );
    return let( rate$, rate$$, let( nper$, nper$$, let( pv$, pv$$, let( fv$, fv$$, fun( Function.IF, op( Operator.EQUAL, rate, cst( 0.0 ) ), op( Operator.DIV, op( Operator.MINUS, op( Operator.PLUS, pv, fv ) ), nper ), let( a$, op( Operator.EXP, op( Operator.PLUS, cst( 1.0 ), rate ), nper ), let( b$, op( Operator.DIV, pv, op( Operator.MINUS, cst( 1.0 ), op( Operator.DIV, cst( 1.0 ), a ) ) ), let( c$, op( Operator.DIV, fv, op( Operator.MINUS, a, cst( 1.0 ) ) ), let( d$, op( Operator.TIMES, op( Operator.MINUS, op( Operator.PLUS, b, c ) ), rate ), fun( Function.IF, op( Operator.GREATER, type, cst( 0.0 ) ), op( Operator.DIV, d, op( Operator.PLUS, cst( 1.0 ), rate ) ), d ) ) ) ) ) ) ) ) ) );
  }

  private final ExpressionNode rewritePV_3( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode rate = substitution( args.next() );
    final ExpressionNode nper = substitution( args.next() );
    final ExpressionNode pmt = substitution( args.next() );
    return fun( Function.PV, rate, nper, pmt, cst( 0.0 ), cst( 0.0 ) );
  }

  private final ExpressionNode rewritePV_4( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode rate = substitution( args.next() );
    final ExpressionNode nper = substitution( args.next() );
    final ExpressionNode pmt = substitution( args.next() );
    final ExpressionNode fv = substitution( args.next() );
    return fun( Function.PV, rate, nper, pmt, fv, cst( 0.0 ) );
  }

  private final ExpressionNode rewritePV_5( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final String rate$ = "rate__" + newSanitizingSuffix();
    final ExpressionNode rate = var( rate$ );
    final ExpressionNode rate$$ = args.next();
    final String nper$ = "nper__" + newSanitizingSuffix();
    final ExpressionNode nper = var( nper$ );
    final ExpressionNode nper$$ = args.next();
    final String pmt$ = "pmt__" + newSanitizingSuffix();
    final ExpressionNode pmt = var( pmt$ );
    final ExpressionNode pmt$$ = args.next();
    final String fv$ = "fv__" + newSanitizingSuffix();
    final ExpressionNode fv = var( fv$ );
    final ExpressionNode fv$$ = args.next();
    final ExpressionNode type = substitution( args.next() );
    final String a$ = "a__" + newSanitizingSuffix();
    final ExpressionNode a = var( a$ );
    final String b$ = "b__" + newSanitizingSuffix();
    final ExpressionNode b = var( b$ );
    return let( rate$, rate$$, let( nper$, nper$$, let( pmt$, pmt$$, let( fv$, fv$$, fun( Function.IF, op( Operator.EQUAL, rate, cst( 0.0 ) ), op( Operator.MINUS, op( Operator.MINUS, fv ), op( Operator.TIMES, pmt, nper ) ), let( a$, op( Operator.PLUS, cst( 1.0 ), rate ), let( b$, op( Operator.TIMES, op( Operator.MINUS, fv ), op( Operator.EXP, a, op( Operator.MINUS, nper ) ) ), fun( Function.IF, op( Operator.GREATER, type, cst( 0.0 ) ), op( Operator.MINUS, op( Operator.PLUS, b, op( Operator.DIV, op( Operator.TIMES, pmt, op( Operator.MINUS, op( Operator.EXP, a, op( Operator.PLUS, op( Operator.MINUS, nper ), cst( 1.0 ) ) ), cst( 1.0 ) ) ), rate ) ), pmt ), op( Operator.PLUS, b, op( Operator.DIV, op( Operator.TIMES, pmt, op( Operator.MINUS, op( Operator.EXP, a, op( Operator.MINUS, nper ) ), cst( 1.0 ) ) ), rate ) ) ) ) ) ) ) ) ) );
  }

  private final ExpressionNode rewriteVDB_5( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode cost = substitution( args.next() );
    final ExpressionNode salvage = substitution( args.next() );
    final ExpressionNode life = substitution( args.next() );
    final ExpressionNode start_period = substitution( args.next() );
    final ExpressionNode end_period = substitution( args.next() );
    return fun( Function.VDB, cost, salvage, life, start_period, end_period, cst( 2.0 ), cst( false ) );
  }

  private final ExpressionNode rewriteVDB_6( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode cost = substitution( args.next() );
    final ExpressionNode salvage = substitution( args.next() );
    final ExpressionNode life = substitution( args.next() );
    final ExpressionNode start_period = substitution( args.next() );
    final ExpressionNode end_period = substitution( args.next() );
    final ExpressionNode factor = substitution( args.next() );
    return fun( Function.VDB, cost, salvage, life, start_period, end_period, factor, cst( false ) );
  }

  private final ExpressionNode rewriteRANK_2( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode number = substitution( args.next() );
    final ExpressionNode ref = substitution( args.next() );
    return fun( Function.RANK, number, ref, cst( 0.0 ) );
  }

  private final ExpressionNode rewriteRANK_3( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final String number$ = "number__" + newSanitizingSuffix();
    final ExpressionNode number = var( number$ );
    final ExpressionNode number$$ = args.next();
    final ExpressionNode xs = substitution( args.next() );
    final ExpressionNode order = substitution( args.next() );
    final String r$ = "r__" + newSanitizingSuffix();
    final ExpressionNode r = var( r$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    final String r$a$ = "r$a__" + newSanitizingSuffix();
    final ExpressionNode r$a = var( r$a$ );
    final String xi$b$ = "xi$b__" + newSanitizingSuffix();
    final ExpressionNode xi$b = var( xi$b$ );
    return let( number$, number$$, fun( Function.IF, op( Operator.EQUAL, order, cst( 0.0 ) ), new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldVectors( new ExpressionNodeForFoldDefinition( new String[] {r$}, new ExpressionNode[] {cst( 1.0 )}, null, new String[] {xi$}, new ExpressionNode[] {op( Operator.PLUS, r, op( Operator.LESS, number, xi ) )}, null, null, null, true, false ), xs ), new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldVectors( new ExpressionNodeForFoldDefinition( new String[] {r$a$}, new ExpressionNode[] {cst( 1.0 )}, null, new String[] {xi$b$}, new ExpressionNode[] {op( Operator.PLUS, r$a, op( Operator.GREATER, number, xi$b ) )}, null, null, null, true, false ), xs ) ) );
  }

  private final ExpressionNode rewriteVAR( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args );
    return new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldList( fold_var(), xs );
  }

  private final ExpressionNode rewriteVARP( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args );
    return new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldList( fold_varp(), xs );
  }

  private final ExpressionNode rewriteSTDEV( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args );
    return fun( Function.SQRT, fun( Function.VAR, xs ) );
  }

  private final ExpressionNode rewriteSTDEVP( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args );
    return fun( Function.SQRT, fun( Function.VARP, xs ) );
  }

  private final ExpressionNode rewriteAVEDEV( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args );
    final String n$ = "n__" + newSanitizingSuffix();
    final ExpressionNode n = var( n$ );
    final String m$ = "m__" + newSanitizingSuffix();
    final ExpressionNode m = var( m$ );
    final String r$ = "r__" + newSanitizingSuffix();
    final ExpressionNode r = var( r$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    return let( n$, fun( Function.COUNT, xs ), let( m$, op( Operator.DIV, fun( Function.SUM, xs ), n ), op( Operator.DIV, new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldList( new ExpressionNodeForFoldDefinition( new String[] {r$}, new ExpressionNode[] {cst( 0.0 )}, null, new String[] {xi$}, new ExpressionNode[] {op( Operator.PLUS, r, fun( Function.ABS, op( Operator.MINUS, m, xi ) ) )}, null, null, null, true, false ), xs ), n ) ) );
  }

  private final ExpressionNode rewriteDEVSQ( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args );
    final String n$ = "n__" + newSanitizingSuffix();
    final ExpressionNode n = var( n$ );
    final String m$ = "m__" + newSanitizingSuffix();
    final ExpressionNode m = var( m$ );
    final String r$ = "r__" + newSanitizingSuffix();
    final ExpressionNode r = var( r$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    final String ei$ = "ei__" + newSanitizingSuffix();
    final ExpressionNode ei = var( ei$ );
    return let( n$, fun( Function.COUNT, xs ), let( m$, op( Operator.DIV, fun( Function.SUM, xs ), n ), new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldList( new ExpressionNodeForFoldDefinition( new String[] {r$}, new ExpressionNode[] {cst( 0.0 )}, null, new String[] {xi$}, new ExpressionNode[] {op( Operator.PLUS, r, let( ei$, op( Operator.MINUS, xi, m ), op( Operator.TIMES, ei, ei ) ) )}, null, null, null, true, false ), xs ) ) );
  }

  private final ExpressionNode rewriteCOVAR_2( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args.next() );
    final ExpressionNode ys = substitution( args.next() );
    final String sx$ = "sx__" + newSanitizingSuffix();
    final ExpressionNode sx = var( sx$ );
    final String sy$ = "sy__" + newSanitizingSuffix();
    final ExpressionNode sy = var( sy$ );
    final String sxy$ = "sxy__" + newSanitizingSuffix();
    final ExpressionNode sxy = var( sxy$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    final String yi$ = "yi__" + newSanitizingSuffix();
    final ExpressionNode yi = var( yi$ );
    final String n$ = "n__" + newSanitizingSuffix();
    final ExpressionNode n = var( n$ );
    return fun( Function.IF, op( Operator.NOTEQUAL, fun( Function.COUNT, xs ), fun( Function.COUNT, ys ) ), fun( Function.NA ), new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldVectors( new ExpressionNodeForFoldDefinition( new String[] {sx$, sy$, sxy$}, new ExpressionNode[] {cst( 0.0 ), cst( 0.0 ), cst( 0.0 )}, null, new String[] {xi$, yi$}, new ExpressionNode[] {op( Operator.PLUS, sx, xi ), op( Operator.PLUS, sy, yi ), op( Operator.PLUS, sxy, op( Operator.TIMES, xi, yi ) )}, n$, op( Operator.DIV, op( Operator.MINUS, sxy, op( Operator.DIV, op( Operator.TIMES, sx, sy ), n ) ), n ), fun( Function.ERROR, cst( "#DIV/0! because list doesn't contain numbers in COVAR" ) ), true, false ), xs, ys ) );
  }

  private final ExpressionNode rewriteSKEW( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args );
    final String n$ = "n__" + newSanitizingSuffix();
    final ExpressionNode n = var( n$ );
    final String s$ = "s__" + newSanitizingSuffix();
    final ExpressionNode s = var( s$ );
    final String s3$ = "s3__" + newSanitizingSuffix();
    final ExpressionNode s3 = var( s3$ );
    final String m$ = "m__" + newSanitizingSuffix();
    final ExpressionNode m = var( m$ );
    final String r$ = "r__" + newSanitizingSuffix();
    final ExpressionNode r = var( r$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    final String ei$ = "ei__" + newSanitizingSuffix();
    final ExpressionNode ei = var( ei$ );
    return let( n$, fun( Function.COUNT, xs ), let( s$, fun( Function.STDEV, xs ), let( s3$, op( Operator.TIMES, op( Operator.TIMES, s, s ), s ), let( m$, op( Operator.DIV, fun( Function.SUM, xs ), n ), op( Operator.DIV, op( Operator.TIMES, op( Operator.DIV, new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldList( new ExpressionNodeForFoldDefinition( new String[] {r$}, new ExpressionNode[] {cst( 0.0 )}, null, new String[] {xi$}, new ExpressionNode[] {op( Operator.PLUS, r, let( ei$, op( Operator.MINUS, xi, m ), op( Operator.TIMES, op( Operator.TIMES, ei, ei ), ei ) ) )}, null, null, null, true, false ), xs ), s3 ), n ), op( Operator.TIMES, op( Operator.MINUS, n, cst( 1.0 ) ), op( Operator.MINUS, n, cst( 2.0 ) ) ) ) ) ) ) );
  }

  private final ExpressionNode rewriteKURT( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args );
    final String n$ = "n__" + newSanitizingSuffix();
    final ExpressionNode n = var( n$ );
    final String a$ = "a__" + newSanitizingSuffix();
    final ExpressionNode a = var( a$ );
    final String b$ = "b__" + newSanitizingSuffix();
    final ExpressionNode b = var( b$ );
    final String s$ = "s__" + newSanitizingSuffix();
    final ExpressionNode s = var( s$ );
    final String m$ = "m__" + newSanitizingSuffix();
    final ExpressionNode m = var( m$ );
    final String r$ = "r__" + newSanitizingSuffix();
    final ExpressionNode r = var( r$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    final String ei$ = "ei__" + newSanitizingSuffix();
    final ExpressionNode ei = var( ei$ );
    final String ei2$ = "ei2__" + newSanitizingSuffix();
    final ExpressionNode ei2 = var( ei2$ );
    return let( n$, fun( Function.COUNT, xs ), let( a$, op( Operator.MINUS, n, cst( 1.0 ) ), let( b$, op( Operator.TIMES, op( Operator.MINUS, n, cst( 2.0 ) ), op( Operator.MINUS, n, cst( 3.0 ) ) ), let( s$, fun( Function.STDEV, xs ), let( m$, op( Operator.DIV, fun( Function.SUM, xs ), n ), op( Operator.MINUS, op( Operator.DIV, op( Operator.TIMES, op( Operator.TIMES, new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldList( new ExpressionNodeForFoldDefinition( new String[] {r$}, new ExpressionNode[] {cst( 0.0 )}, null, new String[] {xi$}, new ExpressionNode[] {op( Operator.PLUS, r, let( ei$, op( Operator.DIV, op( Operator.MINUS, xi, m ), s ), let( ei2$, op( Operator.TIMES, ei, ei ), op( Operator.TIMES, ei2, ei2 ) ) ) )}, null, null, null, true, false ), xs ), n ), op( Operator.PLUS, n, cst( 1.0 ) ) ), op( Operator.TIMES, a, b ) ), op( Operator.DIV, op( Operator.TIMES, op( Operator.TIMES, cst( 3.0 ), a ), a ), b ) ) ) ) ) ) );
  }

  private final ExpressionNode rewriteCONFIDENCE_3( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final String alpha$ = "alpha__" + newSanitizingSuffix();
    final ExpressionNode alpha = var( alpha$ );
    final ExpressionNode alpha$$ = args.next();
    final String sigma$ = "sigma__" + newSanitizingSuffix();
    final ExpressionNode sigma = var( sigma$ );
    final ExpressionNode sigma$$ = args.next();
    final String n$ = "n__" + newSanitizingSuffix();
    final ExpressionNode n = var( n$ );
    final ExpressionNode n$$ = args.next();
    return let( alpha$, alpha$$, let( sigma$, sigma$$, let( n$, n$$, fun( Function.IF, fun( Function.OR, op( Operator.LESSOREQUAL, alpha, cst( 0.0 ) ), op( Operator.GREATEROREQUAL, alpha, cst( 1.0 ) ) ), fun( Function.ERROR, cst( "#NUM! because not 0 < alpha < 1 in CONFIDENCE" ) ), fun( Function.IF, op( Operator.LESSOREQUAL, sigma, cst( 0.0 ) ), fun( Function.ERROR, cst( "#NUM! because sigma <= 0 in CONFIDENCE" ) ), fun( Function.IF, op( Operator.LESS, n, cst( 1.0 ) ), fun( Function.ERROR, cst( "#NUM! because n < 1 in CONFIDENCE" ) ), op( Operator.DIV, op( Operator.TIMES, fun( Function.NORMSINV, op( Operator.MINUS, cst( 1.0 ), op( Operator.DIV, alpha, cst( 2.0 ) ) ) ), sigma ), fun( Function.SQRT, fun( Function.INT, n ) ) ) ) ) ) ) ) );
  }

  private final ExpressionNode rewriteNORMDIST_4( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final String x$ = "x__" + newSanitizingSuffix();
    final ExpressionNode x = var( x$ );
    final ExpressionNode x$$ = args.next();
    final String mue$ = "mue__" + newSanitizingSuffix();
    final ExpressionNode mue = var( mue$ );
    final ExpressionNode mue$$ = args.next();
    final String sigma$ = "sigma__" + newSanitizingSuffix();
    final ExpressionNode sigma = var( sigma$ );
    final ExpressionNode sigma$$ = args.next();
    final ExpressionNode cumulative = substitution( args.next() );
    final String x1$ = "x1__" + newSanitizingSuffix();
    final ExpressionNode x1 = var( x1$ );
    return let( x$, x$$, let( mue$, mue$$, let( sigma$, sigma$$, fun( Function.IF, op( Operator.LESSOREQUAL, sigma, cst( 0.0 ) ), fun( Function.ERROR, cst( "#NUM! because sigma <= 0 in NORMDIST" ) ), fun( Function.IF, cumulative, fun( Function.NORMSDIST, op( Operator.DIV, op( Operator.MINUS, x, mue ), sigma ) ), let( x1$, op( Operator.MINUS, x, mue ), op( Operator.DIV, fun( Function.EXP, op( Operator.DIV, op( Operator.TIMES, x1, x1 ), op( Operator.TIMES, op( Operator.TIMES, op( Operator.MINUS, cst( 2.0 ) ), sigma ), sigma ) ) ), op( Operator.TIMES, fun( Function.SQRT, op( Operator.TIMES, cst( 2.0 ), fun( Function.PI ) ) ), sigma ) ) ) ) ) ) ) );
  }

  private final ExpressionNode rewriteNORMSDIST_1( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode a = substitution( args.next() );
    final String sqrth$ = "sqrth__" + newSanitizingSuffix();
    final ExpressionNode sqrth = var( sqrth$ );
    final String x$ = "x__" + newSanitizingSuffix();
    final ExpressionNode x = var( x$ );
    final String z$ = "z__" + newSanitizingSuffix();
    final ExpressionNode z = var( z$ );
    final String y1$ = "y1__" + newSanitizingSuffix();
    final ExpressionNode y1 = var( y1$ );
    return let( sqrth$, cst( 0.7071067811865476 ), let( x$, op( Operator.TIMES, a, sqrth ), let( z$, fun( Function.ABS, x ), fun( Function.IF, op( Operator.LESS, z, sqrth ), op( Operator.PLUS, cst( 0.5 ), op( Operator.TIMES, cst( 0.5 ), fun( Function.ERF, x ) ) ), let( y1$, op( Operator.TIMES, cst( 0.5 ), fun( Function.ERFC, z ) ), fun( Function.IF, op( Operator.GREATER, x, cst( 0.0 ) ), op( Operator.MINUS, cst( 1.0 ), y1 ), y1 ) ) ) ) ) );
  }

  private final ExpressionNode rewriteNORMINV_3( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final String x$ = "x__" + newSanitizingSuffix();
    final ExpressionNode x = var( x$ );
    final ExpressionNode x$$ = args.next();
    final ExpressionNode mue = substitution( args.next() );
    final String sigma$ = "sigma__" + newSanitizingSuffix();
    final ExpressionNode sigma = var( sigma$ );
    final ExpressionNode sigma$$ = args.next();
    return let( x$, x$$, let( sigma$, sigma$$, fun( Function.IF, fun( Function.OR, op( Operator.LESSOREQUAL, x, cst( 0.0 ) ), op( Operator.GREATEROREQUAL, x, cst( 1.0 ) ) ), fun( Function.ERROR, cst( "#NUM! because not 0 < x < 1 in NORMINV" ) ), fun( Function.IF, op( Operator.LESSOREQUAL, sigma, cst( 0.0 ) ), fun( Function.ERROR, cst( "#NUM! because sigma <= 0 in NORMINV" ) ), op( Operator.PLUS, op( Operator.TIMES, fun( Function.NORMSINV, x ), sigma ), mue ) ) ) ) );
  }

  private final ExpressionNode rewriteNORMSINV_1( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final String x$ = "x__" + newSanitizingSuffix();
    final ExpressionNode x = var( x$ );
    final ExpressionNode x$$ = args.next();
    final String q$ = "q__" + newSanitizingSuffix();
    final ExpressionNode q = var( q$ );
    final String t$ = "t__" + newSanitizingSuffix();
    final ExpressionNode t = var( t$ );
    final String tt$ = "tt__" + newSanitizingSuffix();
    final ExpressionNode tt = var( tt$ );
    final String z$ = "z__" + newSanitizingSuffix();
    final ExpressionNode z = var( z$ );
    final String t$a$ = "t$a__" + newSanitizingSuffix();
    final ExpressionNode t$a = var( t$a$ );
    final String t$b$ = "t$b__" + newSanitizingSuffix();
    final ExpressionNode t$b = var( t$b$ );
    return let( x$, x$$, fun( Function.IF, fun( Function.OR, op( Operator.LESSOREQUAL, x, cst( 0.0 ) ), op( Operator.GREATEROREQUAL, x, cst( 1.0 ) ) ), fun( Function.ERROR, cst( "#NUM! because not 0 < x < 1 in NORMSINV" ) ), let( q$, op( Operator.MINUS, x, cst( 0.5 ) ), fun( Function.IF, op( Operator.LESSOREQUAL, fun( Function.ABS, q ), cst( 0.425 ) ), let( t$, op( Operator.MINUS, cst( 0.180625 ), op( Operator.TIMES, q, q ) ), op( Operator.DIV, op( Operator.TIMES, q, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, t, cst( 2509.0809287301227 ) ), cst( 33430.57558358813 ) ), t ), cst( 67265.7709270087 ) ), t ), cst( 45921.95393154987 ) ), t ), cst( 13731.69376550946 ) ), t ), cst( 1971.5909503065513 ) ), t ), cst( 133.14166789178438 ) ), t ), cst( 3.3871328727963665 ) ) ), op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, t, cst( 5226.495278852854 ) ), cst( 28729.085735721943 ) ), t ), cst( 39307.89580009271 ) ), t ), cst( 21213.794301586597 ) ), t ), cst( 5394.196021424751 ) ), t ), cst( 687.1870074920579 ) ), t ), cst( 42.31333070160091 ) ), t ), cst( 1.0 ) ) ) ), let( tt$, fun( Function.SQRT, op( Operator.MINUS, fun( Function.LN, fun( Function.IF, op( Operator.GREATER, q, cst( 0.0 ) ), op( Operator.MINUS, cst( 1.0 ), x ), x ) ) ) ), let( z$, fun( Function.IF, op( Operator.LESSOREQUAL, tt, cst( 5.0 ) ), let( t$a$, op( Operator.MINUS, tt, cst( 1.6 ) ), op( Operator.DIV, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, t$a, cst( 7.745450142783414E-4 ) ), cst( 0.022723844989269184 ) ), t$a ), cst( 0.2417807251774506 ) ), t$a ), cst( 1.2704582524523684 ) ), t$a ), cst( 3.6478483247632045 ) ), t$a ), cst( 5.769497221460691 ) ), t$a ), cst( 4.630337846156546 ) ), t$a ), cst( 1.4234371107496835 ) ), op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, t$a, cst( 1.0507500716444169E-9 ) ), cst( 5.475938084995345E-4 ) ), t$a ), cst( 0.015198666563616457 ) ), t$a ), cst( 0.14810397642748008 ) ), t$a ), cst( 0.6897673349851 ) ), t$a ), cst( 1.6763848301838038 ) ), t$a ), cst( 2.053191626637759 ) ), t$a ), cst( 1.0 ) ) ) ), let( t$b$, op( Operator.MINUS, tt, cst( 5.0 ) ), op( Operator.DIV, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, t$b, cst( 2.0103343992922881E-7 ) ), cst( 2.7115555687434876E-5 ) ), t$b ), cst( 0.0012426609473880784 ) ), t$b ), cst( 0.026532189526576124 ) ), t$b ), cst( 0.29656057182850487 ) ), t$b ), cst( 1.7848265399172913 ) ), t$b ), cst( 5.463784911164114 ) ), t$b ), cst( 6.657904643501103 ) ), op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, op( Operator.PLUS, op( Operator.TIMES, t$b, cst( 2.0442631033899397E-15 ) ), cst( 1.421511758316446E-7 ) ), t$b ), cst( 1.8463183175100548E-5 ) ), t$b ), cst( 7.868691311456133E-4 ) ), t$b ), cst( 0.014875361290850615 ) ), t$b ), cst( 0.1369298809227358 ) ), t$b ), cst( 0.599832206555888 ) ), t$b ), cst( 1.0 ) ) ) ) ), fun( Function.IF, op( Operator.LESS, q, cst( 0.0 ) ), op( Operator.MINUS, z ), z ) ) ) ) ) ) );
  }

  private final ExpressionNode rewriteLOGNORMDIST_3( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final String x$ = "x__" + newSanitizingSuffix();
    final ExpressionNode x = var( x$ );
    final ExpressionNode x$$ = args.next();
    final ExpressionNode mue = substitution( args.next() );
    final String sigma$ = "sigma__" + newSanitizingSuffix();
    final ExpressionNode sigma = var( sigma$ );
    final ExpressionNode sigma$$ = args.next();
    return let( x$, x$$, let( sigma$, sigma$$, fun( Function.IF, op( Operator.LESSOREQUAL, x, cst( 0.0 ) ), fun( Function.ERROR, cst( "#NUM! because x <= 0 in LOGNORMDIST" ) ), fun( Function.IF, op( Operator.LESSOREQUAL, sigma, cst( 0.0 ) ), fun( Function.ERROR, cst( "#NUM! because sigma <= 0 in LOGNORMDIST" ) ), fun( Function.NORMSDIST, op( Operator.DIV, op( Operator.MINUS, fun( Function.LN, x ), mue ), sigma ) ) ) ) ) );
  }

  private final ExpressionNode rewriteLOGINV_3( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final String x$ = "x__" + newSanitizingSuffix();
    final ExpressionNode x = var( x$ );
    final ExpressionNode x$$ = args.next();
    final ExpressionNode mue = substitution( args.next() );
    final String sigma$ = "sigma__" + newSanitizingSuffix();
    final ExpressionNode sigma = var( sigma$ );
    final ExpressionNode sigma$$ = args.next();
    return let( x$, x$$, let( sigma$, sigma$$, fun( Function.IF, fun( Function.OR, op( Operator.LESSOREQUAL, x, cst( 0.0 ) ), op( Operator.GREATEROREQUAL, x, cst( 1.0 ) ) ), fun( Function.ERROR, cst( "#NUM! because not 0 < x < 1 in LOGINV" ) ), fun( Function.IF, op( Operator.LESSOREQUAL, sigma, cst( 0.0 ) ), fun( Function.ERROR, cst( "#NUM! because sigma <= 0 in LOGINV" ) ), fun( Function.EXP, op( Operator.PLUS, op( Operator.TIMES, fun( Function.NORMSINV, x ), sigma ), mue ) ) ) ) ) );
  }

  private final ExpressionNode rewriteBETADIST_4( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode x = substitution( args.next() );
    final ExpressionNode alpha = substitution( args.next() );
    final ExpressionNode beta = substitution( args.next() );
    final ExpressionNode a = substitution( args.next() );
    return fun( Function.BETADIST, x, alpha, beta, a, cst( 1.0 ) );
  }

  private final ExpressionNode rewriteBETADIST_5( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final String x$ = "x__" + newSanitizingSuffix();
    final ExpressionNode x = var( x$ );
    final ExpressionNode x$$ = args.next();
    final ExpressionNode alpha = substitution( args.next() );
    final ExpressionNode beta = substitution( args.next() );
    final String a$ = "a__" + newSanitizingSuffix();
    final ExpressionNode a = var( a$ );
    final ExpressionNode a$$ = args.next();
    final String b$ = "b__" + newSanitizingSuffix();
    final ExpressionNode b = var( b$ );
    final ExpressionNode b$$ = args.next();
    return let( x$, x$$, let( a$, a$$, let( b$, b$$, fun( Function.IF, fun( Function.OR, op( Operator.LESS, x, a ), op( Operator.GREATER, x, b ) ), fun( Function.ERROR, cst( "#NUM! because not a <= x <= b in BETADIST" ) ), fun( Function.IF, op( Operator.EQUAL, a, b ), fun( Function.ERROR, cst( "#NUM! because a = b in BETADIST" ) ), fun( Function.BETADIST, op( Operator.DIV, op( Operator.MINUS, x, a ), op( Operator.MINUS, b, a ) ), alpha, beta ) ) ) ) ) );
  }

  private final ExpressionNode rewriteBETAINV_4( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode x = substitution( args.next() );
    final ExpressionNode alpha = substitution( args.next() );
    final ExpressionNode beta = substitution( args.next() );
    final ExpressionNode a = substitution( args.next() );
    return fun( Function.BETAINV, x, alpha, beta, a, cst( 1.0 ) );
  }

  private final ExpressionNode rewriteBETAINV_5( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final String x$ = "x__" + newSanitizingSuffix();
    final ExpressionNode x = var( x$ );
    final ExpressionNode x$$ = args.next();
    final ExpressionNode alpha = substitution( args.next() );
    final ExpressionNode beta = substitution( args.next() );
    final String a$ = "a__" + newSanitizingSuffix();
    final ExpressionNode a = var( a$ );
    final ExpressionNode a$$ = args.next();
    final String b$ = "b__" + newSanitizingSuffix();
    final ExpressionNode b = var( b$ );
    final ExpressionNode b$$ = args.next();
    return let( x$, x$$, let( a$, a$$, let( b$, b$$, fun( Function.IF, fun( Function.OR, op( Operator.LESS, x, a ), op( Operator.GREATER, x, b ) ), fun( Function.ERROR, cst( "#NUM! because not a <= x <= b in BETAINV" ) ), fun( Function.IF, op( Operator.EQUAL, a, b ), fun( Function.ERROR, cst( "#NUM! because a = b in BETAINV" ) ), op( Operator.PLUS, op( Operator.TIMES, fun( Function.BETAINV, x, alpha, beta ), op( Operator.MINUS, b, a ) ), a ) ) ) ) ) );
  }

  private final ExpressionNode rewriteCHITEST_6( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args.next() );
    final ExpressionNode ys = substitution( args.next() );
    final String colsX$ = "colsX__" + newSanitizingSuffix();
    final ExpressionNode colsX = var( colsX$ );
    final ExpressionNode colsX$$ = args.next();
    final String rowsX$ = "rowsX__" + newSanitizingSuffix();
    final ExpressionNode rowsX = var( rowsX$ );
    final ExpressionNode rowsX$$ = args.next();
    final ExpressionNode colsY = substitution( args.next() );
    final ExpressionNode rowsY = substitution( args.next() );
    final String chi$ = "chi__" + newSanitizingSuffix();
    final ExpressionNode chi = var( chi$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    final String yi$ = "yi__" + newSanitizingSuffix();
    final ExpressionNode yi = var( yi$ );
    final String n$ = "n__" + newSanitizingSuffix();
    final ExpressionNode n = var( n$ );
    final String df$ = "df__" + newSanitizingSuffix();
    final ExpressionNode df = var( df$ );
    final String df$a$ = "df$a__" + newSanitizingSuffix();
    final ExpressionNode df$a = var( df$a$ );
    return let( colsX$, colsX$$, let( rowsX$, rowsX$$, fun( Function.IF, fun( Function.OR, op( Operator.NOTEQUAL, fun( Function.COUNT, xs ), fun( Function.COUNT, ys ) ), op( Operator.LESSOREQUAL, fun( Function.COUNT, xs ), cst( 1.0 ) ) ), fun( Function.NA ), new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldVectors( new ExpressionNodeForFoldDefinition( new String[] {chi$}, new ExpressionNode[] {cst( 0.0 )}, null, new String[] {xi$, yi$}, new ExpressionNode[] {op( Operator.PLUS, chi, op( Operator.DIV, op( Operator.TIMES, op( Operator.MINUS, xi, yi ), op( Operator.MINUS, xi, yi ) ), yi ) )}, n$, fun( Function.IF, fun( Function.OR, op( Operator.EQUAL, colsX, cst( 1.0 ) ), op( Operator.EQUAL, rowsX, cst( 1.0 ) ) ), let( df$, op( Operator.MINUS, op( Operator.TIMES, colsX, rowsX ), cst( 1.0 ) ), fun( Function.CHIDIST, chi, df ) ), let( df$a$, op( Operator.TIMES, op( Operator.MINUS, colsX, cst( 1.0 ) ), op( Operator.MINUS, rowsX, cst( 1.0 ) ) ), fun( Function.CHIDIST, chi, df$a ) ) ), null, true, false ), xs, ys ) ) ) );
  }

  private final ExpressionNode rewriteEXPONDIST_3( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final String x$ = "x__" + newSanitizingSuffix();
    final ExpressionNode x = var( x$ );
    final ExpressionNode x$$ = args.next();
    final String lambda$ = "lambda__" + newSanitizingSuffix();
    final ExpressionNode lambda = var( lambda$ );
    final ExpressionNode lambda$$ = args.next();
    final ExpressionNode kum = substitution( args.next() );
    return let( x$, x$$, let( lambda$, lambda$$, fun( Function.IF, fun( Function.OR, op( Operator.LESSOREQUAL, lambda, cst( 0.0 ) ), op( Operator.LESS, x, cst( 0.0 ) ) ), fun( Function.ERROR, cst( "#NUM! because lambda <= 0 or x < 0 in EXPONDIST" ) ), fun( Function.IF, op( Operator.EQUAL, kum, cst( 0.0 ) ), op( Operator.TIMES, lambda, fun( Function.EXP, op( Operator.TIMES, op( Operator.MINUS, lambda ), x ) ) ), op( Operator.MINUS, cst( 1.0 ), fun( Function.EXP, op( Operator.TIMES, op( Operator.MINUS, lambda ), x ) ) ) ) ) ) );
  }

  private final ExpressionNode rewriteFDIST_3( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final String x$ = "x__" + newSanitizingSuffix();
    final ExpressionNode x = var( x$ );
    final ExpressionNode x$$ = args.next();
    final ExpressionNode df1 = substitution( args.next() );
    final ExpressionNode df2 = substitution( args.next() );
    final String idf1$ = "idf1__" + newSanitizingSuffix();
    final ExpressionNode idf1 = var( idf1$ );
    final String idf2$ = "idf2__" + newSanitizingSuffix();
    final ExpressionNode idf2 = var( idf2$ );
    return let( x$, x$$, let( idf1$, fun( Function.INT, df1 ), let( idf2$, fun( Function.INT, df2 ), fun( Function.IF, fun( Function.OR, op( Operator.LESS, x, cst( 0.0 ) ), op( Operator.LESS, idf1, cst( 1.0 ) ), op( Operator.LESS, idf2, cst( 1.0 ) ) ), fun( Function.ERROR, cst( "#NUM! because x < 0 or df1 < 0 or df2 < 0 in FDIST" ) ), fun( Function.BETADIST, op( Operator.DIV, idf2, op( Operator.PLUS, idf2, op( Operator.TIMES, idf1, x ) ) ), op( Operator.DIV, idf2, cst( 2.0 ) ), op( Operator.DIV, idf1, cst( 2.0 ) ) ) ) ) ) );
  }

  private final ExpressionNode rewriteFTEST_2( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args.next() );
    final ExpressionNode ys = substitution( args.next() );
    final String countX$ = "countX__" + newSanitizingSuffix();
    final ExpressionNode countX = var( countX$ );
    final String countY$ = "countY__" + newSanitizingSuffix();
    final ExpressionNode countY = var( countY$ );
    final String eps$ = "eps__" + newSanitizingSuffix();
    final ExpressionNode eps = var( eps$ );
    final String sumX$ = "sumX__" + newSanitizingSuffix();
    final ExpressionNode sumX = var( sumX$ );
    final String sumSqrX$ = "sumSqrX__" + newSanitizingSuffix();
    final ExpressionNode sumSqrX = var( sumSqrX$ );
    final String sumY$ = "sumY__" + newSanitizingSuffix();
    final ExpressionNode sumY = var( sumY$ );
    final String sumSqrY$ = "sumSqrY__" + newSanitizingSuffix();
    final ExpressionNode sumSqrY = var( sumSqrY$ );
    final String sX$ = "sX__" + newSanitizingSuffix();
    final ExpressionNode sX = var( sX$ );
    final String sY$ = "sY__" + newSanitizingSuffix();
    final ExpressionNode sY = var( sY$ );
    return let( countX$, fun( Function.COUNT, xs ), let( countY$, fun( Function.COUNT, ys ), let( eps$, cst( 1.0E-6 ), fun( Function.IF, fun( Function.OR, op( Operator.LESS, countX, cst( 2.0 ) ), op( Operator.LESS, countY, cst( 2.0 ) ) ), fun( Function.ERROR, cst( "#NUM! because vectors too short (<2) in FTEST" ) ), let( sumX$, fun( Function.SUM, xs ), let( sumSqrX$, fun( Function.SUMSQ, xs ), let( sumY$, fun( Function.SUM, ys ), let( sumSqrY$, fun( Function.SUMSQ, ys ), let( sX$, op( Operator.DIV, op( Operator.MINUS, sumSqrX, op( Operator.DIV, op( Operator.TIMES, sumX, sumX ), countX ) ), op( Operator.MINUS, countX, cst( 1.0 ) ) ), let( sY$, op( Operator.DIV, op( Operator.MINUS, sumSqrY, op( Operator.DIV, op( Operator.TIMES, sumY, sumY ), countY ) ), op( Operator.MINUS, countY, cst( 1.0 ) ) ), fun( Function.IF, fun( Function.OR, op( Operator.LESS, fun( Function.ABS, sX ), eps ), op( Operator.LESS, fun( Function.ABS, sY ), eps ) ), fun( Function.ERROR, cst( "#DIV/0! in FTEST" ) ), fun( Function.IF, op( Operator.GREATER, sX, sY ), op( Operator.TIMES, cst( 2.0 ), fun( Function.FDIST, op( Operator.DIV, sX, sY ), op( Operator.MINUS, countX, cst( 1.0 ) ), op( Operator.MINUS, countY, cst( 1.0 ) ) ) ), op( Operator.TIMES, cst( 2.0 ), fun( Function.FDIST, op( Operator.DIV, sY, sX ), op( Operator.MINUS, countY, cst( 1.0 ) ), op( Operator.MINUS, countX, cst( 1.0 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) );
  }

  private final ExpressionNode rewriteFISHER_1( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final String x$ = "x__" + newSanitizingSuffix();
    final ExpressionNode x = var( x$ );
    final ExpressionNode x$$ = args.next();
    return let( x$, x$$, fun( Function.IF, op( Operator.GREATEROREQUAL, fun( Function.ABS, x ), cst( 1.0 ) ), fun( Function.ERROR, cst( "#NUM! because not -1 < x < 1 in FISHER" ) ), op( Operator.DIV, fun( Function.LN, op( Operator.DIV, op( Operator.PLUS, cst( 1.0 ), x ), op( Operator.MINUS, cst( 1.0 ), x ) ) ), cst( 2.0 ) ) ) );
  }

  private final ExpressionNode rewriteFISHERINV_1( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final String x$ = "x__" + newSanitizingSuffix();
    final ExpressionNode x = var( x$ );
    final ExpressionNode x$$ = args.next();
    return let( x$, x$$, op( Operator.DIV, op( Operator.MINUS, fun( Function.EXP, op( Operator.TIMES, cst( 2.0 ), x ) ), cst( 1.0 ) ), op( Operator.PLUS, fun( Function.EXP, op( Operator.TIMES, cst( 2.0 ), x ) ), cst( 1.0 ) ) ) );
  }

  private final ExpressionNode rewriteNEGBINOMDIST_3( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final String x$ = "x__" + newSanitizingSuffix();
    final ExpressionNode x = var( x$ );
    final ExpressionNode x$$ = args.next();
    final String r$ = "r__" + newSanitizingSuffix();
    final ExpressionNode r = var( r$ );
    final ExpressionNode r$$ = args.next();
    final String p$ = "p__" + newSanitizingSuffix();
    final ExpressionNode p = var( p$ );
    final ExpressionNode p$$ = args.next();
    final String ix$ = "ix__" + newSanitizingSuffix();
    final ExpressionNode ix = var( ix$ );
    final String ir$ = "ir__" + newSanitizingSuffix();
    final ExpressionNode ir = var( ir$ );
    return let( x$, x$$, let( r$, r$$, let( p$, p$$, fun( Function.IF, fun( Function.NOT, fun( Function.AND, op( Operator.LESS, cst( 0.0 ), p ), op( Operator.LESS, p, cst( 1.0 ) ), op( Operator.GREATEROREQUAL, x, cst( 0.0 ) ), op( Operator.GREATEROREQUAL, r, cst( 1.0 ) ) ) ), fun( Function.ERROR, cst( "#NUM! because not 0 < p < 1, x >= 0, r >= 1 in NEGBINOMDIST" ) ), let( ix$, fun( Function.INT, x ), let( ir$, fun( Function.INT, r ), op( Operator.TIMES, op( Operator.TIMES, fun( Function.COMBIN, op( Operator.MINUS, op( Operator.PLUS, ix, ir ), cst( 1.0 ) ), op( Operator.MINUS, ir, cst( 1.0 ) ) ), op( Operator.EXP, p, ir ) ), op( Operator.EXP, op( Operator.MINUS, cst( 1.0 ), p ), ix ) ) ) ) ) ) ) );
  }

  private final ExpressionNode rewritePEARSON_2( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args.next() );
    final ExpressionNode ys = substitution( args.next() );
    final String countX$ = "countX__" + newSanitizingSuffix();
    final ExpressionNode countX = var( countX$ );
    final String countY$ = "countY__" + newSanitizingSuffix();
    final ExpressionNode countY = var( countY$ );
    final String sumX$ = "sumX__" + newSanitizingSuffix();
    final ExpressionNode sumX = var( sumX$ );
    final String sumY$ = "sumY__" + newSanitizingSuffix();
    final ExpressionNode sumY = var( sumY$ );
    final String sumSqrX$ = "sumSqrX__" + newSanitizingSuffix();
    final ExpressionNode sumSqrX = var( sumSqrX$ );
    final String sumSqrY$ = "sumSqrY__" + newSanitizingSuffix();
    final ExpressionNode sumSqrY = var( sumSqrY$ );
    final String sumXY$ = "sumXY__" + newSanitizingSuffix();
    final ExpressionNode sumXY = var( sumXY$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    final String yi$ = "yi__" + newSanitizingSuffix();
    final ExpressionNode yi = var( yi$ );
    final String n$ = "n__" + newSanitizingSuffix();
    final ExpressionNode n = var( n$ );
    final String tmp_val$ = "tmp_val__" + newSanitizingSuffix();
    final ExpressionNode tmp_val = var( tmp_val$ );
    return let( countX$, fun( Function.COUNT, xs ), let( countY$, fun( Function.COUNT, ys ), fun( Function.IF, fun( Function.OR, op( Operator.EQUAL, countX, cst( 0.0 ) ), op( Operator.NOTEQUAL, countY, countX ) ), fun( Function.NA ), new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldVectors( new ExpressionNodeForFoldDefinition( new String[] {sumX$, sumY$, sumSqrX$, sumSqrY$, sumXY$}, new ExpressionNode[] {cst( 0.0 ), cst( 0.0 ), cst( 0.0 ), cst( 0.0 ), cst( 0.0 )}, null, new String[] {xi$, yi$}, new ExpressionNode[] {op( Operator.PLUS, sumX, xi ), op( Operator.PLUS, sumY, yi ), op( Operator.PLUS, sumSqrX, op( Operator.TIMES, xi, xi ) ), op( Operator.PLUS, sumSqrY, op( Operator.TIMES, yi, yi ) ), op( Operator.PLUS, sumXY, op( Operator.TIMES, xi, yi ) )}, n$, let( tmp_val$, op( Operator.TIMES, op( Operator.MINUS, op( Operator.TIMES, n, sumSqrX ), op( Operator.TIMES, sumX, sumX ) ), op( Operator.MINUS, op( Operator.TIMES, n, sumSqrY ), op( Operator.TIMES, sumY, sumY ) ) ), op( Operator.DIV, op( Operator.MINUS, op( Operator.TIMES, n, sumXY ), op( Operator.TIMES, sumX, sumY ) ), fun( Function.SQRT, tmp_val ) ) ), null, true, false ), xs, ys ) ) ) );
  }

  private final ExpressionNode rewriteRSQ_2( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args.next() );
    final ExpressionNode ys = substitution( args.next() );
    final String countX$ = "countX__" + newSanitizingSuffix();
    final ExpressionNode countX = var( countX$ );
    final String countY$ = "countY__" + newSanitizingSuffix();
    final ExpressionNode countY = var( countY$ );
    final String sumX$ = "sumX__" + newSanitizingSuffix();
    final ExpressionNode sumX = var( sumX$ );
    final String sumY$ = "sumY__" + newSanitizingSuffix();
    final ExpressionNode sumY = var( sumY$ );
    final String sumSqrX$ = "sumSqrX__" + newSanitizingSuffix();
    final ExpressionNode sumSqrX = var( sumSqrX$ );
    final String sumSqrY$ = "sumSqrY__" + newSanitizingSuffix();
    final ExpressionNode sumSqrY = var( sumSqrY$ );
    final String sumXY$ = "sumXY__" + newSanitizingSuffix();
    final ExpressionNode sumXY = var( sumXY$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    final String yi$ = "yi__" + newSanitizingSuffix();
    final ExpressionNode yi = var( yi$ );
    final String n$ = "n__" + newSanitizingSuffix();
    final ExpressionNode n = var( n$ );
    final String tmp_val1$ = "tmp_val1__" + newSanitizingSuffix();
    final ExpressionNode tmp_val1 = var( tmp_val1$ );
    final String tmp_val2$ = "tmp_val2__" + newSanitizingSuffix();
    final ExpressionNode tmp_val2 = var( tmp_val2$ );
    return let( countX$, fun( Function.COUNT, xs ), let( countY$, fun( Function.COUNT, ys ), fun( Function.IF, fun( Function.OR, op( Operator.EQUAL, countX, cst( 0.0 ) ), op( Operator.NOTEQUAL, countY, countX ) ), fun( Function.NA ), new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldVectors( new ExpressionNodeForFoldDefinition( new String[] {sumX$, sumY$, sumSqrX$, sumSqrY$, sumXY$}, new ExpressionNode[] {cst( 0.0 ), cst( 0.0 ), cst( 0.0 ), cst( 0.0 ), cst( 0.0 )}, null, new String[] {xi$, yi$}, new ExpressionNode[] {op( Operator.PLUS, sumX, xi ), op( Operator.PLUS, sumY, yi ), op( Operator.PLUS, sumSqrX, op( Operator.TIMES, xi, xi ) ), op( Operator.PLUS, sumSqrY, op( Operator.TIMES, yi, yi ) ), op( Operator.PLUS, sumXY, op( Operator.TIMES, xi, yi ) )}, n$, let( tmp_val1$, op( Operator.MINUS, op( Operator.TIMES, n, sumSqrX ), op( Operator.TIMES, sumX, sumX ) ), let( tmp_val2$, op( Operator.MINUS, op( Operator.TIMES, n, sumSqrY ), op( Operator.TIMES, sumY, sumY ) ), op( Operator.DIV, op( Operator.DIV, op( Operator.TIMES, op( Operator.MINUS, op( Operator.TIMES, n, sumXY ), op( Operator.TIMES, sumX, sumY ) ), op( Operator.MINUS, op( Operator.TIMES, n, sumXY ), op( Operator.TIMES, sumX, sumY ) ) ), tmp_val1 ), tmp_val2 ) ) ), null, true, false ), xs, ys ) ) ) );
  }

  private final ExpressionNode rewriteSTANDARDIZE_3( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode x = substitution( args.next() );
    final ExpressionNode mue = substitution( args.next() );
    final String sigma$ = "sigma__" + newSanitizingSuffix();
    final ExpressionNode sigma = var( sigma$ );
    final ExpressionNode sigma$$ = args.next();
    return let( sigma$, sigma$$, fun( Function.IF, op( Operator.LESSOREQUAL, sigma, cst( 0.0 ) ), fun( Function.ERROR, cst( "#NUM! because sigma <= 0 in STANDARDIZE" ) ), op( Operator.DIV, op( Operator.MINUS, x, mue ), sigma ) ) );
  }

  private final ExpressionNode rewriteTTEST_4( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args.next() );
    final ExpressionNode ys = substitution( args.next() );
    final String tails$ = "tails__" + newSanitizingSuffix();
    final ExpressionNode tails = var( tails$ );
    final ExpressionNode tails$$ = args.next();
    final String type$ = "type__" + newSanitizingSuffix();
    final ExpressionNode type = var( type$ );
    final ExpressionNode type$$ = args.next();
    final String countX$ = "countX__" + newSanitizingSuffix();
    final ExpressionNode countX = var( countX$ );
    final String countY$ = "countY__" + newSanitizingSuffix();
    final ExpressionNode countY = var( countY$ );
    final String sumX$ = "sumX__" + newSanitizingSuffix();
    final ExpressionNode sumX = var( sumX$ );
    final String sumY$ = "sumY__" + newSanitizingSuffix();
    final ExpressionNode sumY = var( sumY$ );
    final String sumSqrX$ = "sumSqrX__" + newSanitizingSuffix();
    final ExpressionNode sumSqrX = var( sumSqrX$ );
    final String sumSqrY$ = "sumSqrY__" + newSanitizingSuffix();
    final ExpressionNode sumSqrY = var( sumSqrY$ );
    final String sumSqrD$ = "sumSqrD__" + newSanitizingSuffix();
    final ExpressionNode sumSqrD = var( sumSqrD$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    final String yi$ = "yi__" + newSanitizingSuffix();
    final ExpressionNode yi = var( yi$ );
    final String denom$ = "denom__" + newSanitizingSuffix();
    final ExpressionNode denom = var( denom$ );
    final String t$ = "t__" + newSanitizingSuffix();
    final ExpressionNode t = var( t$ );
    final String f$ = "f__" + newSanitizingSuffix();
    final ExpressionNode f = var( f$ );
    final String sX$ = "sX__" + newSanitizingSuffix();
    final ExpressionNode sX = var( sX$ );
    final String sY$ = "sY__" + newSanitizingSuffix();
    final ExpressionNode sY = var( sY$ );
    final String tmp_val$ = "tmp_val__" + newSanitizingSuffix();
    final ExpressionNode tmp_val = var( tmp_val$ );
    final String t$a$ = "t$a__" + newSanitizingSuffix();
    final ExpressionNode t$a = var( t$a$ );
    final String f$b$ = "f$b__" + newSanitizingSuffix();
    final ExpressionNode f$b = var( f$b$ );
    final String sX$c$ = "sX$c__" + newSanitizingSuffix();
    final ExpressionNode sX$c = var( sX$c$ );
    final String sY$d$ = "sY$d__" + newSanitizingSuffix();
    final ExpressionNode sY$d = var( sY$d$ );
    final String t$e$ = "t$e__" + newSanitizingSuffix();
    final ExpressionNode t$e = var( t$e$ );
    final String f$f$ = "f$f__" + newSanitizingSuffix();
    final ExpressionNode f$f = var( f$f$ );
    return let( tails$, tails$$, let( type$, type$$, fun( Function.IF, fun( Function.AND, op( Operator.NOTEQUAL, tails, cst( 1.0 ) ), op( Operator.NOTEQUAL, tails, cst( 2.0 ) ) ), fun( Function.ERROR, cst( "#NUM! because not tails in {1,2} in TTEST" ) ), let( countX$, fun( Function.COUNT, xs ), let( countY$, fun( Function.COUNT, ys ), let( sumX$, fun( Function.SUM, xs ), let( sumY$, fun( Function.SUM, ys ), let( sumSqrX$, fun( Function.SUMSQ, xs ), let( sumSqrY$, fun( Function.SUMSQ, ys ), fun( Function.IF, op( Operator.EQUAL, type, cst( 1.0 ) ), fun( Function.IF, fun( Function.OR, op( Operator.NOTEQUAL, countX, countY ), op( Operator.LESS, countX, cst( 1.0 ) ) ), fun( Function.NA ), new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldVectors( new ExpressionNodeForFoldDefinition( new String[] {sumSqrD$}, new ExpressionNode[] {cst( 0.0 )}, null, new String[] {xi$, yi$}, new ExpressionNode[] {op( Operator.PLUS, sumSqrD, op( Operator.TIMES, op( Operator.MINUS, xi, yi ), op( Operator.MINUS, xi, yi ) ) )}, null, let( denom$, op( Operator.MINUS, op( Operator.TIMES, countX, sumSqrD ), op( Operator.TIMES, op( Operator.MINUS, sumX, sumY ), op( Operator.MINUS, sumX, sumY ) ) ), fun( Function.IF, op( Operator.LESSOREQUAL, denom, cst( 0.0 ) ), fun( Function.ERROR, cst( "#DIV/0! in TTEST" ) ), let( t$, op( Operator.DIV, op( Operator.TIMES, fun( Function.SQRT, op( Operator.MINUS, countX, cst( 1.0 ) ) ), fun( Function.ABS, op( Operator.MINUS, sumX, sumY ) ) ), fun( Function.SQRT, denom ) ), let( f$, op( Operator.MINUS, countX, cst( 1.0 ) ), fun( Function.TDIST, t, f, tails ) ) ) ) ), null, true, false ), xs, ys ) ), fun( Function.IF, op( Operator.EQUAL, type, cst( 2.0 ) ), fun( Function.IF, fun( Function.OR, op( Operator.LESSOREQUAL, countX, cst( 1.0 ) ), op( Operator.LESSOREQUAL, countY, cst( 1.0 ) ) ), fun( Function.ERROR, cst( "#NUM! because vectors too short (<2)  in TTEST" ) ), let( sX$, op( Operator.DIV, op( Operator.MINUS, sumSqrX, op( Operator.DIV, op( Operator.TIMES, sumX, sumX ), countX ) ), op( Operator.MINUS, countX, cst( 1.0 ) ) ), let( sY$, op( Operator.DIV, op( Operator.MINUS, sumSqrY, op( Operator.DIV, op( Operator.TIMES, sumY, sumY ), countY ) ), op( Operator.MINUS, countY, cst( 1.0 ) ) ), let( tmp_val$, op( Operator.PLUS, op( Operator.TIMES, op( Operator.MINUS, countX, cst( 1.0 ) ), sX ), op( Operator.TIMES, op( Operator.MINUS, countY, cst( 1.0 ) ), sY ) ), let( t$a$, op( Operator.TIMES, op( Operator.DIV, fun( Function.ABS, op( Operator.MINUS, op( Operator.DIV, sumX, countX ), op( Operator.DIV, sumY, countY ) ) ), fun( Function.SQRT, tmp_val ) ), fun( Function.SQRT, op( Operator.DIV, op( Operator.TIMES, op( Operator.TIMES, countX, countY ), op( Operator.MINUS, op( Operator.PLUS, countX, countY ), cst( 2.0 ) ) ), op( Operator.PLUS, countX, countY ) ) ) ), let( f$b$, op( Operator.MINUS, op( Operator.PLUS, countX, countY ), cst( 2.0 ) ), fun( Function.TDIST, t$a, f$b, tails ) ) ) ) ) ) ), fun( Function.IF, op( Operator.EQUAL, type, cst( 3.0 ) ), fun( Function.IF, fun( Function.OR, op( Operator.LESSOREQUAL, countX, cst( 1.0 ) ), op( Operator.LESSOREQUAL, countY, cst( 1.0 ) ) ), fun( Function.ERROR, cst( "#NUM! because vectors too short (<2)  in TTEST" ) ), let( sX$c$, op( Operator.DIV, op( Operator.DIV, op( Operator.MINUS, sumSqrX, op( Operator.DIV, op( Operator.TIMES, sumX, sumX ), countX ) ), op( Operator.MINUS, countX, cst( 1.0 ) ) ), countX ), let( sY$d$, op( Operator.DIV, op( Operator.DIV, op( Operator.MINUS, sumSqrY, op( Operator.DIV, op( Operator.TIMES, sumY, sumY ), countY ) ), op( Operator.MINUS, countY, cst( 1.0 ) ) ), countY ), let( t$e$, op( Operator.DIV, fun( Function.ABS, op( Operator.MINUS, op( Operator.DIV, sumX, countX ), op( Operator.DIV, sumY, countY ) ) ), fun( Function.SQRT, op( Operator.PLUS, sX$c, sY$d ) ) ), let( f$f$, op( Operator.DIV, op( Operator.TIMES, op( Operator.PLUS, sX$c, sY$d ), op( Operator.PLUS, sX$c, sY$d ) ), op( Operator.PLUS, op( Operator.DIV, op( Operator.TIMES, sX$c, sX$c ), op( Operator.MINUS, countX, cst( 1.0 ) ) ), op( Operator.DIV, op( Operator.TIMES, sY$d, sY$d ), op( Operator.MINUS, countY, cst( 1.0 ) ) ) ) ), fun( Function.TDIST, t$e, f$f, tails, cst( 1.0 ) ) ) ) ) ) ), fun( Function.ERROR, cst( "#NUM! because not type in {1, 2, 3} in TTEST" ) ) ) ) ) ) ) ) ) ) ) ) ) );
  }

  private final ExpressionNode rewriteZTEST_2( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args.next() );
    final ExpressionNode x = substitution( args.next() );
    final String sigma$ = "sigma__" + newSanitizingSuffix();
    final ExpressionNode sigma = var( sigma$ );
    return let( sigma$, fun( Function.STDEV, xs ), fun( Function.ZTEST, xs, x, sigma ) );
  }

  private final ExpressionNode rewriteZTEST_3( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args.next() );
    final ExpressionNode mue = substitution( args.next() );
    final String sigma$ = "sigma__" + newSanitizingSuffix();
    final ExpressionNode sigma = var( sigma$ );
    final ExpressionNode sigma$$ = args.next();
    final String countXs$ = "countXs__" + newSanitizingSuffix();
    final ExpressionNode countXs = var( countXs$ );
    final String medXs$ = "medXs__" + newSanitizingSuffix();
    final ExpressionNode medXs = var( medXs$ );
    return let( sigma$, sigma$$, let( countXs$, fun( Function.COUNT, xs ), fun( Function.IF, op( Operator.LESS, countXs, cst( 1.0 ) ), fun( Function.NA ), fun( Function.IF, op( Operator.LESSOREQUAL, sigma, cst( 0.0 ) ), fun( Function.ERROR, cst( "#NUM! because sigma <= 0 in ZTEST" ) ), let( medXs$, fun( Function.AVERAGE, xs ), op( Operator.MINUS, cst( 1.0 ), fun( Function.NORMSDIST, op( Operator.DIV, op( Operator.MINUS, medXs, mue ), op( Operator.DIV, sigma, fun( Function.SQRT, countXs ) ) ) ) ) ) ) ) ) );
  }

  private final ExpressionNode rewriteSTDEVPA( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args );
    return fun( Function.STDEVP, xs );
  }

  private final ExpressionNode rewriteSUMX2MY2_2( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args.next() );
    final ExpressionNode ys = substitution( args.next() );
    final String sxy$ = "sxy__" + newSanitizingSuffix();
    final ExpressionNode sxy = var( sxy$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    final String yi$ = "yi__" + newSanitizingSuffix();
    final ExpressionNode yi = var( yi$ );
    return fun( Function.IF, op( Operator.NOTEQUAL, fun( Function.COUNT, xs ), fun( Function.COUNT, ys ) ), fun( Function.NA ), new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldVectors( new ExpressionNodeForFoldDefinition( new String[] {sxy$}, new ExpressionNode[] {cst( 0.0 )}, null, new String[] {xi$, yi$}, new ExpressionNode[] {op( Operator.MINUS, op( Operator.PLUS, sxy, op( Operator.TIMES, xi, xi ) ), op( Operator.TIMES, yi, yi ) )}, null, sxy, null, true, false ), xs, ys ) );
  }

  private final ExpressionNode rewriteSUMX2PY2_2( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args.next() );
    final ExpressionNode ys = substitution( args.next() );
    final String sxy$ = "sxy__" + newSanitizingSuffix();
    final ExpressionNode sxy = var( sxy$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    final String yi$ = "yi__" + newSanitizingSuffix();
    final ExpressionNode yi = var( yi$ );
    return fun( Function.IF, op( Operator.NOTEQUAL, fun( Function.COUNT, xs ), fun( Function.COUNT, ys ) ), fun( Function.NA ), new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldVectors( new ExpressionNodeForFoldDefinition( new String[] {sxy$}, new ExpressionNode[] {cst( 0.0 )}, null, new String[] {xi$, yi$}, new ExpressionNode[] {op( Operator.PLUS, op( Operator.PLUS, sxy, op( Operator.TIMES, xi, xi ) ), op( Operator.TIMES, yi, yi ) )}, null, sxy, null, true, false ), xs, ys ) );
  }

  private final ExpressionNode rewriteSUMXMY2_2( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args.next() );
    final ExpressionNode ys = substitution( args.next() );
    final String sxy$ = "sxy__" + newSanitizingSuffix();
    final ExpressionNode sxy = var( sxy$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    final String yi$ = "yi__" + newSanitizingSuffix();
    final ExpressionNode yi = var( yi$ );
    final String xmy$ = "xmy__" + newSanitizingSuffix();
    final ExpressionNode xmy = var( xmy$ );
    return fun( Function.IF, op( Operator.NOTEQUAL, fun( Function.COUNT, xs ), fun( Function.COUNT, ys ) ), fun( Function.NA ), new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldVectors( new ExpressionNodeForFoldDefinition( new String[] {sxy$}, new ExpressionNode[] {cst( 0.0 )}, null, new String[] {xi$, yi$}, new ExpressionNode[] {op( Operator.PLUS, sxy, let( xmy$, op( Operator.MINUS, xi, yi ), op( Operator.TIMES, xmy, xmy ) ) )}, null, sxy, null, true, false ), xs, ys ) );
  }

  private final ExpressionNode rewriteVARA( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args );
    return fun( Function.VAR, xs );
  }

  private final ExpressionNode rewriteSTEYX_2( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode ys = substitution( args.next() );
    final ExpressionNode xs = substitution( args.next() );
    final String countX$ = "countX__" + newSanitizingSuffix();
    final ExpressionNode countX = var( countX$ );
    final String countY$ = "countY__" + newSanitizingSuffix();
    final ExpressionNode countY = var( countY$ );
    final String sumX$ = "sumX__" + newSanitizingSuffix();
    final ExpressionNode sumX = var( sumX$ );
    final String sumY$ = "sumY__" + newSanitizingSuffix();
    final ExpressionNode sumY = var( sumY$ );
    final String sumSqrX$ = "sumSqrX__" + newSanitizingSuffix();
    final ExpressionNode sumSqrX = var( sumSqrX$ );
    final String sumSqrY$ = "sumSqrY__" + newSanitizingSuffix();
    final ExpressionNode sumSqrY = var( sumSqrY$ );
    final String sumXY$ = "sumXY__" + newSanitizingSuffix();
    final ExpressionNode sumXY = var( sumXY$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    final String yi$ = "yi__" + newSanitizingSuffix();
    final ExpressionNode yi = var( yi$ );
    final String n$ = "n__" + newSanitizingSuffix();
    final ExpressionNode n = var( n$ );
    final String var1$ = "var1__" + newSanitizingSuffix();
    final ExpressionNode var1 = var( var1$ );
    return let( countX$, fun( Function.COUNT, xs ), let( countY$, fun( Function.COUNT, ys ), fun( Function.IF, op( Operator.NOTEQUAL, countY, countX ), fun( Function.NA ), fun( Function.IF, op( Operator.LESS, countX, cst( 3.0 ) ), fun( Function.ERROR, cst( "#DIV/0! because vectors too short (<3) in STEYX" ) ), new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldVectors( new ExpressionNodeForFoldDefinition( new String[] {sumX$, sumY$, sumSqrX$, sumSqrY$, sumXY$}, new ExpressionNode[] {cst( 0.0 ), cst( 0.0 ), cst( 0.0 ), cst( 0.0 ), cst( 0.0 )}, null, new String[] {xi$, yi$}, new ExpressionNode[] {op( Operator.PLUS, sumX, xi ), op( Operator.PLUS, sumY, yi ), op( Operator.PLUS, sumSqrX, op( Operator.TIMES, xi, xi ) ), op( Operator.PLUS, sumSqrY, op( Operator.TIMES, yi, yi ) ), op( Operator.PLUS, sumXY, op( Operator.TIMES, xi, yi ) )}, n$, let( var1$, op( Operator.DIV, op( Operator.DIV, op( Operator.MINUS, op( Operator.MINUS, op( Operator.TIMES, n, sumSqrY ), op( Operator.TIMES, sumY, sumY ) ), op( Operator.DIV, op( Operator.TIMES, op( Operator.MINUS, op( Operator.TIMES, n, sumXY ), op( Operator.TIMES, sumX, sumY ) ), op( Operator.MINUS, op( Operator.TIMES, n, sumXY ), op( Operator.TIMES, sumX, sumY ) ) ), op( Operator.MINUS, op( Operator.TIMES, n, sumSqrX ), op( Operator.TIMES, sumX, sumX ) ) ) ), n ), op( Operator.MINUS, n, cst( 2.0 ) ) ), fun( Function.SQRT, var1 ) ), null, true, false ), xs, ys ) ) ) ) );
  }

  private final ExpressionNode rewriteCORREL_2( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args.next() );
    final ExpressionNode ys = substitution( args.next() );
    final String countX$ = "countX__" + newSanitizingSuffix();
    final ExpressionNode countX = var( countX$ );
    final String countY$ = "countY__" + newSanitizingSuffix();
    final ExpressionNode countY = var( countY$ );
    final String sumX$ = "sumX__" + newSanitizingSuffix();
    final ExpressionNode sumX = var( sumX$ );
    final String sumY$ = "sumY__" + newSanitizingSuffix();
    final ExpressionNode sumY = var( sumY$ );
    final String sumSqrX$ = "sumSqrX__" + newSanitizingSuffix();
    final ExpressionNode sumSqrX = var( sumSqrX$ );
    final String sumSqrY$ = "sumSqrY__" + newSanitizingSuffix();
    final ExpressionNode sumSqrY = var( sumSqrY$ );
    final String sumXY$ = "sumXY__" + newSanitizingSuffix();
    final ExpressionNode sumXY = var( sumXY$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    final String yi$ = "yi__" + newSanitizingSuffix();
    final ExpressionNode yi = var( yi$ );
    final String n$ = "n__" + newSanitizingSuffix();
    final ExpressionNode n = var( n$ );
    return let( countX$, fun( Function.COUNT, xs ), let( countY$, fun( Function.COUNT, ys ), fun( Function.IF, op( Operator.NOTEQUAL, countY, countX ), fun( Function.NA ), new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldVectors( new ExpressionNodeForFoldDefinition( new String[] {sumX$, sumY$, sumSqrX$, sumSqrY$, sumXY$}, new ExpressionNode[] {cst( 0.0 ), cst( 0.0 ), cst( 0.0 ), cst( 0.0 ), cst( 0.0 )}, null, new String[] {xi$, yi$}, new ExpressionNode[] {op( Operator.PLUS, sumX, xi ), op( Operator.PLUS, sumY, yi ), op( Operator.PLUS, sumSqrX, op( Operator.TIMES, xi, xi ) ), op( Operator.PLUS, sumSqrY, op( Operator.TIMES, yi, yi ) ), op( Operator.PLUS, sumXY, op( Operator.TIMES, xi, yi ) )}, n$, op( Operator.DIV, op( Operator.MINUS, sumXY, op( Operator.DIV, op( Operator.TIMES, sumX, sumY ), n ) ), fun( Function.SQRT, op( Operator.TIMES, op( Operator.MINUS, sumSqrX, op( Operator.DIV, op( Operator.TIMES, sumX, sumX ), n ) ), op( Operator.MINUS, sumSqrY, op( Operator.DIV, op( Operator.TIMES, sumY, sumY ), n ) ) ) ) ), null, true, false ), xs, ys ) ) ) );
  }

  private final ExpressionNode rewriteINTERCEPT_2( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode ys = substitution( args.next() );
    final ExpressionNode xs = substitution( args.next() );
    final String countX$ = "countX__" + newSanitizingSuffix();
    final ExpressionNode countX = var( countX$ );
    final String countY$ = "countY__" + newSanitizingSuffix();
    final ExpressionNode countY = var( countY$ );
    final String sumX$ = "sumX__" + newSanitizingSuffix();
    final ExpressionNode sumX = var( sumX$ );
    final String sumY$ = "sumY__" + newSanitizingSuffix();
    final ExpressionNode sumY = var( sumY$ );
    final String sumSqrX$ = "sumSqrX__" + newSanitizingSuffix();
    final ExpressionNode sumSqrX = var( sumSqrX$ );
    final String sumXY$ = "sumXY__" + newSanitizingSuffix();
    final ExpressionNode sumXY = var( sumXY$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    final String yi$ = "yi__" + newSanitizingSuffix();
    final ExpressionNode yi = var( yi$ );
    final String n$ = "n__" + newSanitizingSuffix();
    final ExpressionNode n = var( n$ );
    return let( countX$, fun( Function.COUNT, xs ), let( countY$, fun( Function.COUNT, ys ), fun( Function.IF, op( Operator.NOTEQUAL, countY, countX ), fun( Function.NA ), new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldVectors( new ExpressionNodeForFoldDefinition( new String[] {sumX$, sumY$, sumSqrX$, sumXY$}, new ExpressionNode[] {cst( 0.0 ), cst( 0.0 ), cst( 0.0 ), cst( 0.0 )}, null, new String[] {xi$, yi$}, new ExpressionNode[] {op( Operator.PLUS, sumX, xi ), op( Operator.PLUS, sumY, yi ), op( Operator.PLUS, sumSqrX, op( Operator.TIMES, xi, xi ) ), op( Operator.PLUS, sumXY, op( Operator.TIMES, xi, yi ) )}, n$, op( Operator.DIV, op( Operator.MINUS, sumY, op( Operator.TIMES, op( Operator.DIV, op( Operator.MINUS, op( Operator.TIMES, n, sumXY ), op( Operator.TIMES, sumX, sumY ) ), op( Operator.MINUS, op( Operator.TIMES, n, sumSqrX ), op( Operator.TIMES, sumX, sumX ) ) ), sumX ) ), n ), null, true, false ), xs, ys ) ) ) );
  }

  private final ExpressionNode rewriteSLOPE_2( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode ys = substitution( args.next() );
    final ExpressionNode xs = substitution( args.next() );
    final String countX$ = "countX__" + newSanitizingSuffix();
    final ExpressionNode countX = var( countX$ );
    final String countY$ = "countY__" + newSanitizingSuffix();
    final ExpressionNode countY = var( countY$ );
    final String sumX$ = "sumX__" + newSanitizingSuffix();
    final ExpressionNode sumX = var( sumX$ );
    final String sumY$ = "sumY__" + newSanitizingSuffix();
    final ExpressionNode sumY = var( sumY$ );
    final String sumSqrX$ = "sumSqrX__" + newSanitizingSuffix();
    final ExpressionNode sumSqrX = var( sumSqrX$ );
    final String sumXY$ = "sumXY__" + newSanitizingSuffix();
    final ExpressionNode sumXY = var( sumXY$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    final String yi$ = "yi__" + newSanitizingSuffix();
    final ExpressionNode yi = var( yi$ );
    final String n$ = "n__" + newSanitizingSuffix();
    final ExpressionNode n = var( n$ );
    return let( countX$, fun( Function.COUNT, xs ), let( countY$, fun( Function.COUNT, ys ), fun( Function.IF, op( Operator.NOTEQUAL, countY, countX ), fun( Function.NA ), new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldVectors( new ExpressionNodeForFoldDefinition( new String[] {sumX$, sumY$, sumSqrX$, sumXY$}, new ExpressionNode[] {cst( 0.0 ), cst( 0.0 ), cst( 0.0 ), cst( 0.0 )}, null, new String[] {xi$, yi$}, new ExpressionNode[] {op( Operator.PLUS, sumX, xi ), op( Operator.PLUS, sumY, yi ), op( Operator.PLUS, sumSqrX, op( Operator.TIMES, xi, xi ) ), op( Operator.PLUS, sumXY, op( Operator.TIMES, xi, yi ) )}, n$, op( Operator.DIV, op( Operator.MINUS, op( Operator.TIMES, n, sumXY ), op( Operator.TIMES, sumX, sumY ) ), op( Operator.MINUS, op( Operator.TIMES, n, sumSqrX ), op( Operator.TIMES, sumX, sumX ) ) ), null, true, false ), xs, ys ) ) ) );
  }

  private final ExpressionNode rewriteFORECAST_3( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode x = substitution( args.next() );
    final ExpressionNode ys = substitution( args.next() );
    final ExpressionNode xs = substitution( args.next() );
    final String countX$ = "countX__" + newSanitizingSuffix();
    final ExpressionNode countX = var( countX$ );
    final String countY$ = "countY__" + newSanitizingSuffix();
    final ExpressionNode countY = var( countY$ );
    final String sumX$ = "sumX__" + newSanitizingSuffix();
    final ExpressionNode sumX = var( sumX$ );
    final String sumY$ = "sumY__" + newSanitizingSuffix();
    final ExpressionNode sumY = var( sumY$ );
    final String sumSqrX$ = "sumSqrX__" + newSanitizingSuffix();
    final ExpressionNode sumSqrX = var( sumSqrX$ );
    final String sumXY$ = "sumXY__" + newSanitizingSuffix();
    final ExpressionNode sumXY = var( sumXY$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    final String yi$ = "yi__" + newSanitizingSuffix();
    final ExpressionNode yi = var( yi$ );
    final String n$ = "n__" + newSanitizingSuffix();
    final ExpressionNode n = var( n$ );
    return let( countX$, fun( Function.COUNT, xs ), let( countY$, fun( Function.COUNT, ys ), fun( Function.IF, op( Operator.NOTEQUAL, countY, countX ), fun( Function.NA ), new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldVectors( new ExpressionNodeForFoldDefinition( new String[] {sumX$, sumY$, sumSqrX$, sumXY$}, new ExpressionNode[] {cst( 0.0 ), cst( 0.0 ), cst( 0.0 ), cst( 0.0 )}, null, new String[] {xi$, yi$}, new ExpressionNode[] {op( Operator.PLUS, sumX, xi ), op( Operator.PLUS, sumY, yi ), op( Operator.PLUS, sumSqrX, op( Operator.TIMES, xi, xi ) ), op( Operator.PLUS, sumXY, op( Operator.TIMES, xi, yi ) )}, n$, op( Operator.DIV, op( Operator.PLUS, sumY, op( Operator.TIMES, op( Operator.DIV, op( Operator.MINUS, op( Operator.TIMES, n, sumXY ), op( Operator.TIMES, sumX, sumY ) ), op( Operator.MINUS, op( Operator.TIMES, n, sumSqrX ), op( Operator.TIMES, sumX, sumX ) ) ), op( Operator.MINUS, op( Operator.TIMES, n, x ), sumX ) ) ), n ), null, true, false ), xs, ys ) ) ) );
  }

  private final ExpressionNode rewritePROB_3( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args.next() );
    final ExpressionNode ys = substitution( args.next() );
    final String lo_limit$ = "lo_limit__" + newSanitizingSuffix();
    final ExpressionNode lo_limit = var( lo_limit$ );
    final ExpressionNode lo_limit$$ = args.next();
    return let( lo_limit$, lo_limit$$, fun( Function.PROB, xs, ys, lo_limit, lo_limit ) );
  }

  private final ExpressionNode rewritePROB_4( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode ws = substitution( args.next() );
    final ExpressionNode ps = substitution( args.next() );
    final ExpressionNode lo_limit = substitution( args.next() );
    final ExpressionNode up_limit = substitution( args.next() );
    final String res$ = "res__" + newSanitizingSuffix();
    final ExpressionNode res = var( res$ );
    final String sum$ = "sum__" + newSanitizingSuffix();
    final ExpressionNode sum = var( sum$ );
    final String wi$ = "wi__" + newSanitizingSuffix();
    final ExpressionNode wi = var( wi$ );
    final String pi$ = "pi__" + newSanitizingSuffix();
    final ExpressionNode pi = var( pi$ );
    final String n$ = "n__" + newSanitizingSuffix();
    final ExpressionNode n = var( n$ );
    return fun( Function.IF, op( Operator.NOTEQUAL, fun( Function.COUNT, ws ), fun( Function.COUNT, ps ) ), fun( Function.NA ), new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldVectors( new ExpressionNodeForFoldDefinition( new String[] {res$, sum$}, new ExpressionNode[] {cst( 0.0 ), cst( 0.0 )}, null, new String[] {wi$, pi$}, new ExpressionNode[] {op( Operator.PLUS, res, fun( Function.IF, fun( Function.AND, op( Operator.GREATEROREQUAL, wi, lo_limit ), op( Operator.LESSOREQUAL, wi, up_limit ) ), pi, cst( 0.0 ) ) ), op( Operator.PLUS, sum, pi )}, n$, fun( Function.IF, op( Operator.GREATER, fun( Function.ABS, op( Operator.MINUS, sum, cst( 1.0 ) ) ), cst( 1.0E-7 ) ), fun( Function.ERROR, cst( "#NUM! because the sum of probabilities != 1 in PROB" ) ), res ), fun( Function.ERROR, cst( "#DIV/0! because list doesn't contain numbers in PROB" ) ), true, false ), ws, ps ) );
  }

  private final ExpressionNode rewriteLARGE_2( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args.next() );
    final ExpressionNode k = substitution( args.next() );
    return fun( Function.SMALL, xs, op( Operator.PLUS, op( Operator.MINUS, fun( Function.COUNT, xs ), k ), cst( 1.0 ) ) );
  }

  private final ExpressionNode rewriteMEDIAN( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args );
    final String countX$ = "countX__" + newSanitizingSuffix();
    final ExpressionNode countX = var( countX$ );
    final String n$ = "n__" + newSanitizingSuffix();
    final ExpressionNode n = var( n$ );
    return let( countX$, fun( Function.COUNT, xs ), let( n$, fun( Function.INT, op( Operator.DIV, countX, cst( 2.0 ) ) ), fun( Function.IF, op( Operator.EQUAL, op( Operator.DIV, countX, cst( 2.0 ) ), n ), op( Operator.DIV, op( Operator.PLUS, fun( Function.SMALL, xs, n ), fun( Function.SMALL, xs, op( Operator.PLUS, n, cst( 1.0 ) ) ) ), cst( 2.0 ) ), fun( Function.SMALL, xs, op( Operator.PLUS, n, cst( 1.0 ) ) ) ) ) );
  }

  private final ExpressionNode rewriteMODE( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args );
    final String xMed$ = "xMed__" + newSanitizingSuffix();
    final ExpressionNode xMed = var( xMed$ );
    final String xCurr$ = "xCurr__" + newSanitizingSuffix();
    final ExpressionNode xCurr = var( xCurr$ );
    final String countMed$ = "countMed__" + newSanitizingSuffix();
    final ExpressionNode countMed = var( countMed$ );
    final String countCurr$ = "countCurr__" + newSanitizingSuffix();
    final ExpressionNode countCurr = var( countCurr$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    final String countX$ = "countX__" + newSanitizingSuffix();
    final ExpressionNode countX = var( countX$ );
    final String yi$ = "yi__" + newSanitizingSuffix();
    final ExpressionNode yi = var( yi$ );
    return fun( Function.IF, op( Operator.LESS, fun( Function.COUNT, xs ), cst( 2.0 ) ), fun( Function.NA ), new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldList( new ExpressionNodeForFoldDefinition( new String[] {xMed$, xCurr$, countMed$, countCurr$}, new ExpressionNode[] {cst( 0.0 ), cst( 0.0 ), cst( 0.0 ), cst( 0.0 )}, null, new String[] {xi$}, new ExpressionNode[] {fun( Function.IF, op( Operator.GREATER, countCurr, countMed ), xCurr, xMed ), xi, fun( Function.IF, op( Operator.GREATER, countCurr, countMed ), countCurr, countMed ), new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldList( new ExpressionNodeForFoldDefinition( new String[] {countX$}, new ExpressionNode[] {cst( 0.0 )}, null, new String[] {yi$}, new ExpressionNode[] {fun( Function.IF, op( Operator.EQUAL, yi, xi ), op( Operator.PLUS, countX, cst( 1.0 ) ), countX )}, null, fun( Function.IF, op( Operator.GREATER, countX, countCurr ), countX, countCurr ), null, true, false ), xs )}, null, fun( Function.IF, op( Operator.LESSOREQUAL, countMed, cst( 1.0 ) ), fun( Function.NA ), xMed ), fun( Function.NA ), true, false ), xs ) );
  }

  private final ExpressionNode rewritePERCENTILE_2( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args.next() );
    final String k$ = "k__" + newSanitizingSuffix();
    final ExpressionNode k = var( k$ );
    final ExpressionNode k$$ = args.next();
    final String countX$ = "countX__" + newSanitizingSuffix();
    final ExpressionNode countX = var( countX$ );
    final String n$ = "n__" + newSanitizingSuffix();
    final ExpressionNode n = var( n$ );
    final String diff$ = "diff__" + newSanitizingSuffix();
    final ExpressionNode diff = var( diff$ );
    final String val$ = "val__" + newSanitizingSuffix();
    final ExpressionNode val = var( val$ );
    return let( k$, k$$, let( countX$, fun( Function.COUNT, xs ), let( n$, fun( Function.INT, op( Operator.TIMES, k, op( Operator.MINUS, countX, cst( 1.0 ) ) ) ), let( diff$, op( Operator.MINUS, op( Operator.TIMES, k, op( Operator.MINUS, countX, cst( 1.0 ) ) ), n ), let( val$, fun( Function.SMALL, xs, op( Operator.PLUS, n, cst( 1.0 ) ) ), fun( Function.IF, op( Operator.EQUAL, diff, cst( 0.0 ) ), val, op( Operator.PLUS, val, op( Operator.TIMES, diff, op( Operator.MINUS, fun( Function.SMALL, xs, op( Operator.PLUS, n, cst( 2.0 ) ) ), val ) ) ) ) ) ) ) ) );
  }

  private final ExpressionNode rewritePERCENTRANK_2( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args.next() );
    final ExpressionNode x = substitution( args.next() );
    return fun( Function.PERCENTRANK, xs, x, cst( 3.0 ) );
  }

  private final ExpressionNode rewritePERCENTRANK_3( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args.next() );
    final String x$ = "x__" + newSanitizingSuffix();
    final ExpressionNode x = var( x$ );
    final ExpressionNode x$$ = args.next();
    final String significance$ = "significance__" + newSanitizingSuffix();
    final ExpressionNode significance = var( significance$ );
    final ExpressionNode significance$$ = args.next();
    final String countSmaller$ = "countSmaller__" + newSanitizingSuffix();
    final ExpressionNode countSmaller = var( countSmaller$ );
    final String largerX$ = "largerX__" + newSanitizingSuffix();
    final ExpressionNode largerX = var( largerX$ );
    final String smallerX$ = "smallerX__" + newSanitizingSuffix();
    final ExpressionNode smallerX = var( smallerX$ );
    final String minX$ = "minX__" + newSanitizingSuffix();
    final ExpressionNode minX = var( minX$ );
    final String maxX$ = "maxX__" + newSanitizingSuffix();
    final ExpressionNode maxX = var( maxX$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    final String n$ = "n__" + newSanitizingSuffix();
    final ExpressionNode n = var( n$ );
    final String fract$ = "fract__" + newSanitizingSuffix();
    final ExpressionNode fract = var( fract$ );
    return let( x$, x$$, let( significance$, significance$$, fun( Function.IF, op( Operator.LESS, significance, cst( 1.0 ) ), fun( Function.ERROR, cst( "#NUM! because significance < 1 in PERCENTRANK" ) ), new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldVectors( new ExpressionNodeForFoldDefinition( new String[] {countSmaller$, largerX$, smallerX$, minX$, maxX$}, new ExpressionNode[] {cst( 0.0 ), new ExpressionNodeForMaxValue(), new ExpressionNodeForMinValue(), new ExpressionNodeForMaxValue(), new ExpressionNodeForMinValue()}, null, new String[] {xi$}, new ExpressionNode[] {fun( Function.IF, op( Operator.LESS, xi, x ), op( Operator.PLUS, countSmaller, cst( 1.0 ) ), countSmaller ), fun( Function.IF, op( Operator.GREATEROREQUAL, xi, x ), op( Operator.INTERNAL_MIN, xi, largerX ), largerX ), fun( Function.IF, op( Operator.LESSOREQUAL, xi, x ), op( Operator.INTERNAL_MAX, xi, smallerX ), smallerX ), op( Operator.INTERNAL_MIN, minX, xi ), op( Operator.INTERNAL_MAX, maxX, xi )}, n$, fun( Function.IF, op( Operator.EQUAL, largerX, x ), fun( Function.IF, op( Operator.EQUAL, n, cst( 1.0 ) ), cst( 1.0 ), fun( Function.TRUNC, op( Operator.DIV, countSmaller, op( Operator.MINUS, n, cst( 1.0 ) ) ), significance ) ), fun( Function.IF, fun( Function.OR, op( Operator.LESS, x, minX ), op( Operator.GREATER, x, maxX ) ), fun( Function.NA ), let( fract$, op( Operator.DIV, op( Operator.MINUS, x, smallerX ), op( Operator.MINUS, largerX, smallerX ) ), fun( Function.TRUNC, op( Operator.DIV, op( Operator.PLUS, op( Operator.MINUS, countSmaller, cst( 1.0 ) ), fract ), op( Operator.MINUS, n, cst( 1.0 ) ) ), significance ) ) ) ), null, true, false ), xs ) ) ) );
  }

  private final ExpressionNode rewriteQUARTILE_2( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args.next() );
    final String k$ = "k__" + newSanitizingSuffix();
    final ExpressionNode k = var( k$ );
    final ExpressionNode k$$ = args.next();
    return let( k$, k$$, fun( Function.IF, fun( Function.OR, op( Operator.LESS, k, cst( 0.0 ) ), op( Operator.GREATEROREQUAL, k, cst( 5.0 ) ) ), fun( Function.ERROR, cst( "#NUM! because not k < 0 or k >= 5 in QUARTILE" ) ), fun( Function.PERCENTILE, xs, op( Operator.TIMES, cst( 0.25 ), fun( Function.INT, k ) ) ) ) );
  }

  private final ExpressionNode rewriteSMALL_2( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args.next() );
    final String k$ = "k__" + newSanitizingSuffix();
    final ExpressionNode k = var( k$ );
    final ExpressionNode k$$ = args.next();
    final String x$ = "x__" + newSanitizingSuffix();
    final ExpressionNode x = var( x$ );
    final String num$ = "num__" + newSanitizingSuffix();
    final ExpressionNode num = var( num$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    final String el$ = "el__" + newSanitizingSuffix();
    final ExpressionNode el = var( el$ );
    final String i$ = "i__" + newSanitizingSuffix();
    final ExpressionNode i = var( i$ );
    final String xi$a$ = "xi$a__" + newSanitizingSuffix();
    final ExpressionNode xi$a = var( xi$a$ );
    return let( k$, k$$, fun( Function.IF, fun( Function.OR, op( Operator.GREATER, k, fun( Function.COUNT, xs ) ), op( Operator.LESS, k, cst( 1.0 ) ) ), fun( Function.ERROR, cst( "#NUM! because not 1 <= k <= n in SMALL/LARGE" ) ), new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldVectors( new ExpressionNodeForFoldDefinition( new String[] {x$, num$}, new ExpressionNode[] {op( Operator.MINUS, new ExpressionNodeForMaxValue() ), cst( 1.0 )}, null, new String[] {xi$}, new ExpressionNode[] {fun( Function.IF, op( Operator.GREATER, num, k ), x, new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldVectors( new ExpressionNodeForFoldDefinition( new String[] {el$, i$}, new ExpressionNode[] {new ExpressionNodeForMaxValue(), cst( 0.0 )}, null, new String[] {xi$a$}, new ExpressionNode[] {fun( Function.IF, op( Operator.GREATER, xi$a, x ), op( Operator.INTERNAL_MIN, xi$a, el ), el ), fun( Function.IF, op( Operator.LESSOREQUAL, xi$a, x ), op( Operator.PLUS, i, cst( 1.0 ) ), i )}, null, fun( Function.IF, op( Operator.GREATEROREQUAL, i, num ), x, el ), null, true, false ), xs ) ), op( Operator.PLUS, num, cst( 1.0 ) )}, null, x, fun( Function.NA ), true, false ), xs ) ) );
  }

  private final ExpressionNode rewriteTRIMMEAN_2( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args.next() );
    final String k$ = "k__" + newSanitizingSuffix();
    final ExpressionNode k = var( k$ );
    final ExpressionNode k$$ = args.next();
    final String cut$ = "cut__" + newSanitizingSuffix();
    final ExpressionNode cut = var( cut$ );
    final String max_el$ = "max_el__" + newSanitizingSuffix();
    final ExpressionNode max_el = var( max_el$ );
    final String min_el$ = "min_el__" + newSanitizingSuffix();
    final ExpressionNode min_el = var( min_el$ );
    final String sum$ = "sum__" + newSanitizingSuffix();
    final ExpressionNode sum = var( sum$ );
    final String max_count$ = "max_count__" + newSanitizingSuffix();
    final ExpressionNode max_count = var( max_count$ );
    final String min_count$ = "min_count__" + newSanitizingSuffix();
    final ExpressionNode min_count = var( min_count$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    final String n$ = "n__" + newSanitizingSuffix();
    final ExpressionNode n = var( n$ );
    return let( k$, k$$, fun( Function.IF, fun( Function.OR, op( Operator.LESS, k, cst( 0.0 ) ), op( Operator.GREATEROREQUAL, k, cst( 1.0 ) ) ), fun( Function.ERROR, cst( "#NUM! because not 0 <= k < 1 in TRIMMEAN" ) ), let( cut$, fun( Function.INT, op( Operator.DIV, op( Operator.TIMES, k, fun( Function.COUNT, xs ) ), cst( 2.0 ) ) ), fun( Function.IF, op( Operator.EQUAL, cut, cst( 0.0 ) ), fun( Function.AVERAGE, xs ), let( max_el$, fun( Function.LARGE, xs, cut ), let( min_el$, fun( Function.SMALL, xs, cut ), new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldVectors( new ExpressionNodeForFoldDefinition( new String[] {sum$, max_count$, min_count$}, new ExpressionNode[] {cst( 0.0 ), cst( 0.0 ), cst( 0.0 )}, null, new String[] {xi$}, new ExpressionNode[] {fun( Function.IF, fun( Function.AND, op( Operator.LESS, xi, max_el ), op( Operator.GREATER, xi, min_el ) ), op( Operator.PLUS, sum, xi ), sum ), fun( Function.IF, op( Operator.GREATEROREQUAL, xi, max_el ), op( Operator.PLUS, max_count, cst( 1.0 ) ), max_count ), fun( Function.IF, op( Operator.LESSOREQUAL, xi, min_el ), op( Operator.PLUS, min_count, cst( 1.0 ) ), min_count )}, n$, op( Operator.DIV, op( Operator.PLUS, op( Operator.PLUS, sum, op( Operator.TIMES, op( Operator.MINUS, max_count, cut ), max_el ) ), op( Operator.TIMES, op( Operator.MINUS, min_count, cut ), min_el ) ), op( Operator.MINUS, n, op( Operator.TIMES, cst( 2.0 ), cut ) ) ), null, true, false ), xs ) ) ) ) ) ) );
  }

  private final ExpressionNode rewriteDAYS360_2( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode start_date = substitution( args.next() );
    final ExpressionNode end_date = substitution( args.next() );
    return fun( Function.DAYS360, start_date, end_date, cst( 0.0 ) );
  }

  private final ExpressionNode rewriteSUM( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args );
    return new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldList( fold_sum(), xs );
  }

  private final ExpressionNode rewritePRODUCT( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args );
    return new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldList( fold_product(), xs );
  }

  private final ExpressionNode rewriteMIN( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args );
    return new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldList( fold_min(), xs );
  }

  private final ExpressionNode rewriteMAX( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args );
    return new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldList( fold_max(), xs );
  }

  private final ExpressionNode rewriteCOUNTA( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args );
    return fun( Function.COUNT, xs );
  }

  private final ExpressionNode rewriteAVERAGE( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args );
    return new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldList( fold_average(), xs );
  }

  private final ExpressionNode rewriteSUMSQ( ExpressionNodeForFunction _fun ) {
    final Iterator<ExpressionNode> args = _fun.arguments().iterator();
    final ExpressionNode xs = substitution( args );
    final String s$ = "s__" + newSanitizingSuffix();
    final ExpressionNode s = var( s$ );
    final String xi$ = "xi__" + newSanitizingSuffix();
    final ExpressionNode xi = var( xi$ );
    return new org.formulacompiler.compiler.internal.expressions.ExpressionNodeForFoldList( new ExpressionNodeForFoldDefinition( new String[] {s$}, new ExpressionNode[] {cst( 0.0 )}, null, new String[] {xi$}, new ExpressionNode[] {op( Operator.PLUS, s, op( Operator.TIMES, xi, xi ) )}, null, null, null, true, false ), xs );
  }


}
